// -*- C++ -*-
//---------------
//--- Glob.cc ---
//---------------
/* 
 * Synopsis: 
 * Implementation Notes:
 * ToDo:
 * 
 * $Id: Glob.cc,v 1.1 92/03/29 09:16:48 rvillari Exp Locker: rvillari $
 * $Log:	Glob.cc,v $
Revision 1.1  92/03/29  09:16:48  rvillari
Initial revision

 *
 *
*/

#include "Glob.h"
#include "RexxStream.h"
Glob::Glob() : LineNumber(1), NestingLevel(0), DefaultExtension("rexx"), Version("REXXunix 1.01 Apr 8 1992"), ReasonForReturn(ReasonError), Streams(0), pp1_InvalidCharacter(0), pp1_StringNotTerminated(0), pp1_CommentNotTerminated(0), RaisedSignal(SigSignal), Clause(0), UninitializedAccess(0), Error(ERealError), DefaultAddress("SHELL"), rexx_InvalidHexOrBinString(0), Tokens(0), Clauses(0), SignalIsPending(0) {
}

Glob::~Glob() {
}

// everything you need to do after construction of the glob object

void Glob::Init() {
    BuiltinFunctions.Preload(); // need to initialize glob.BuiltinFunctions
//    Streams["<defaultio>"] = new RexxDefaultStream;
    Streams["stdin"] = new RexxNonSeekableStream("stdin", stdin, FRead);
    Streams["stdout"] = new RexxNonSeekableStream("stdout", stdout, FWrite);
    Tokens = new RexxTokens;
    Tokens2 = new RexxTokens;
    Clauses = new RexxClauses;
    VariableError = "No Error Set for Variable Error!";
}

Glob glob; // define a one of a kind global object where we keep global things


