#ifndef _INTERNALENV_H
#pragma once
#define _INTERNALENV_H

#include "InternalDatap.SLStack.h"
#include <stream.h>
class InternalData;

class InternalEnv {
  public:
    InternalDatapSLStack env;
  public:
    InternalEnv();
    ~InternalEnv();

    inline InternalData* GetData();
    
    void PushEnv();
    void PushEnv(InternalData*);
    InternalData* PopEnv();
};

inline InternalData* InternalEnv::GetData() {
    if (env.empty()) {
	cout << "InternalEnv is empty!\n";
	abort();
    }
    return env.top();
}



#endif
