// -*- C++ -*-
//--------------------
//--- MemoryFile.h ---
//--------------------
/*
 * Responsibility: 
 * Role: 
 * Communications: 
 * Bugs & Caveats: 
 * Created: Sat Mar  7 18:20:52 1992 by rvillari
 * Maintainer: 
 * 
 * $Id: MemoryFile.h,v 1.1 92/03/29 09:19:01 rvillari Exp Locker: rvillari $
 * $Log:	MemoryFile.h,v $
 * Revision 1.1  92/03/29  09:19:01  rvillari
 * Initial revision
 * 
 * 
 * 
*/


#ifndef _MemoryFile_h
#pragma once
#define _MemoryFile_h 1

#include <String.h>

class MemoryFile {
  private:
    String memfile; // actual storage here
    String unputs; // store our unputs here
    int cp; // current pointer
    char* charp_; // points to the char* of memfile
    int length_; // length of the file
  public:
    MemoryFile();
    MemoryFile& operator=(MemoryFile&);
    void reset();
    void clear();
    int input();
    int lines(); // number of lines in this file
    char* getline(int); // returns pointer to buffer containing line
    void unput(int);
    void output(int);
    void output(char*);
    int LoadFromFile(String&); // possibly fails
    void LoadFromString(String&);
    void Debug();
   ~MemoryFile();
};

#endif 
