#ifndef _REXXCLAUSES_H
#pragma once
#define _REXXCLAUSES_H

class Clause;
#include <String.h>
#include "Implementation.h"
#include "Clausep.XPlex.h"

/* really simplistic array implementation! */
/* need to replace with dynamic arrays */
class RexxClauses {
  private:
//    Clause* clauses[MaxClauses];
    ClausepXPlex clauses;
    int pc;
    int freespace;
  public:
    RexxClauses();
    ~RexxClauses();
    void ResetPC();
    void SetPC(int);
    void CheckBound(int);
    void Free(int); // deallocates from arg to freespace
    int Free(); // where are we going to put new clauses?
    int Goto(String, int, int); // reposition on a labelclause matching string
    int Goto(int);
    int Exists(String, int, int); // check if there is a label matching string
    int Find(String, int, int); // return loc. of first label within bounds
    int GetPC();
    void AddClause(Clause*); // adds new clause
    Clause* NextClause();
};
    





#endif
