#ifndef lint
static char yysccsid[] = "@(#)yaccpar	1.8 (Berkeley) 01/02/91\n\
 Modified 5/15/91 by J. Roskind to support graphic debugging modes";
#endif
#define YYBYACC 1
#line 2 "rexxparse.y"
#define YYDEBUG_LEXER_TEXT (yytext) /* our lexer loads this up each time.
				     We are telling the graphical debugger
				     where to find the spelling of the 
				     tokens.*/

/* interface with flex: should be in header file */

#include <stdio.h>
#include <stdlib.h>
/*#include <stream.h>*/
#include "Clause.h"
#include "Express.h"
#include "Expressionp.SLList.h"
#include "InternalData.h"

extern Clause* clause;
extern FILE*	yyin;
extern int	yyerror(char*);
extern int      yylex(void);
int		yyeof = 0;
/*int parsererror = 0;*/

extern char* yytext;
#line 246 "rexxparse.y"
typedef union{
    struct {
	ArgString* string;
	int secondary;
    } symbol;
    ArgString* string;
    Expression* expression;
    ExpressionpSLList* expressionlist;
} YYSTYPE;
#line 41 "rexxparse.tab.c"
#define TOK_OR 257
#define TOK_XOR 258
#define TOK_AND 259
#define TOK_EQUAL 260
#define TOK_GREATER_EQUAL 261
#define TOK_GREATER_THAN 262
#define TOK_LESS_EQUAL 263
#define TOK_LESS_THAN 264
#define TOK_NOT_EQUAL 265
#define TOK_EXACT_EQUAL 266
#define TOK_EXACT_NOT_EQUAL 267
#define TOK_EXACT_GREATER_EQUAL 268
#define TOK_EXACT_GREATER_THAN 269
#define TOK_EXACT_LESS_EQUAL 270
#define TOK_EXACT_LESS_THAN 271
#define TOK_BLANK 272
#define TOK_CONCAT 273
#define TOK_MINUS 274
#define TOK_PLUS 275
#define TOK_INT_DIV 276
#define TOK_REMAINDER 277
#define TOK_REAL_DIV 278
#define TOK_MULT 279
#define NEGATIVE 280
#define POSITIVE 281
#define TOK_EXP 282
#define TOK_NOT 283
#define TOK_COMMA 284
#define TOK_LPAREN 285
#define TOK_RPAREN 286
#define TOK_NEWLINE 287
#define TOK_STRING_LITERAL 288
#define TOK_LABEL 289
#define TOK_COLON 290
#define TOK_SYMBOL 291
#define TOK_FIXED 292
#define TOK_STEM 293
#define TOK_COMPOUND 294
#define TOK_SIMPLE 295
#define TOK_ASSIGNMENT 296
#define TOK_NULLCLAUSE 297
#define TOK_ERRORCLAUSE 298
#define TOK_COMMANDCLAUSE 299
#define TOK_LINENUMBER 300
#define TOK_ADDRESS 301
#define TOK_ADDRESS_SS 302
#define TOK_ADDRESS_VALUE 303
#define TOK_VALUE 304
#define TOK_ARG 305
#define TOK_BREAK 306
#define TOK_CALL 307
#define TOK_ON 308
#define TOK_OFF 309
#define TOK_FAILURE 310
#define TOK_ERROR 311
#define TOK_HALT 312
#define TOK_NOTREADY 313
#define TOK_CALL_ON_FAILURE 314
#define TOK_CALL_ON_ERROR 315
#define TOK_CALL_ON_HALT 316
#define TOK_CALL_ON_NOTREADY 317
#define TOK_CALL_OFF_FAILURE 318
#define TOK_CALL_OFF_ERROR 319
#define TOK_CALL_OFF_HALT 320
#define TOK_CALL_OFF_NOTREADY 321
#define TOK_NAME 322
#define TOK_CALL_ON_FAILURE_NAME 323
#define TOK_CALL_ON_ERROR_NAME 324
#define TOK_CALL_ON_HALT_NAME 325
#define TOK_CALL_ON_NOTREADY_NAME 326
#define TOK_DO 327
#define TOK_TO 328
#define TOK_BY 329
#define TOK_FOR 330
#define TOK_FOREVER 331
#define TOK_WHILE 332
#define TOK_UNTIL 333
#define TOK_DROP 334
#define TOK_SAY 335
#define TOK_ELSE 336
#define TOK_END 337
#define TOK_EXIT 338
#define TOK_EOF 339
#define TOK_IF 340
#define TOK_WHEN 341
#define TOK_THEN 342
#define TOK_INTERPRET 343
#define TOK_ITERATE 344
#define TOK_LEAVE 345
#define TOK_NOP 346
#define TOK_DIGITS 347
#define TOK_FUZZ 348
#define TOK_FORM 349
#define TOK_SCIENTIFIC 350
#define TOK_ENGINEERING 351
#define TOK_NUMERIC 352
#define TOK_NUMERIC_DIGITS 353
#define TOK_NUMERIC_FUZZ 354
#define TOK_NUMERIC_FORM_SCIENTIFIC 355
#define TOK_NUMERIC_FORM_ENGINEERING 356
#define TOK_NUMERIC_FORM_VALUE 357
#define TOK_OPTIONS 358
#define TOK_OTHERWISE 359
#define TOK_LINEIN 360
#define TOK_EXTERNAL 361
#define TOK_SOURCE 362
#define TOK_VAR 363
#define TOK_VERSION 364
#define TOK_PARSE 365
#define TOK_PARSE_ARG 366
#define TOK_PARSE_LINEIN 367
#define TOK_PARSE_EXTERNAL 368
#define TOK_PARSE_PULL 369
#define TOK_PARSE_SOURCE 370
#define TOK_PARSE_VALUE 371
#define TOK_WITH 372
#define TOK_PARSE_VAR 373
#define TOK_PARSE_VERSION 374
#define TOK_PARSE_UPPER_ARG 375
#define TOK_PARSE_UPPER_LINEIN 376
#define TOK_PARSE_UPPER_EXTERNAL 377
#define TOK_PARSE_UPPER_NUMERIC 378
#define TOK_PARSE_UPPER_PULL 379
#define TOK_PARSE_UPPER_SOURCE 380
#define TOK_PARSE_UPPER_VALUE 381
#define TOK_PARSE_UPPER_VAR 382
#define TOK_PARSE_UPPER_VERSION 383
#define TOK_EXPOSE 384
#define TOK_PROCEDURE 385
#define TOK_PROCEDURE_EXPOSE 386
#define TOK_PULL 387
#define TOK_PUSH 388
#define TOK_QUEUE 389
#define TOK_RETURN 390
#define TOK_SELECT 391
#define TOK_SYNTAX 392
#define TOK_NOVALUE 393
#define TOK_SIGNAL 394
#define TOK_SIGNAL_ON_FAILURE 395
#define TOK_SIGNAL_ON_ERROR 396
#define TOK_SIGNAL_ON_HALT 397
#define TOK_SIGNAL_ON_NOTREADY 398
#define TOK_SIGNAL_ON_NOVALUE 399
#define TOK_SIGNAL_ON_SYNTAX 400
#define TOK_SIGNAL_OFF_FAILURE 401
#define TOK_SIGNAL_OFF_ERROR 402
#define TOK_SIGNAL_OFF_HALT 403
#define TOK_SIGNAL_OFF_NOTREADY 404
#define TOK_SIGNAL_OFF_NOVALUE 405
#define TOK_SIGNAL_OFF_SYNTAX 406
#define TOK_SIGNAL_ON_FAILURE_NAME 407
#define TOK_SIGNAL_ON_ERROR_NAME 408
#define TOK_SIGNAL_ON_HALT_NAME 409
#define TOK_SIGNAL_ON_NOTREADY_NAME 410
#define TOK_SIGNAL_ON_NOVALUE_NAME 411
#define TOK_SIGNAL_ON_SYNTAX_NAME 412
#define TOK_SIGNAL_VALUE 413
#define TOK_TRACE 414
#define TOK_TRACE_SS 415
#define TOK_TRACE_VALUE 416
#define TOK_UPPER 417
#define TOK_UNKNOWN 418
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,    0,    0,    0,    0,    0,   10,    5,    6,
    7,    9,   12,    8,   14,    8,   16,    8,   18,    8,
   20,    8,   22,    8,   24,    8,   26,    8,   28,    8,
   30,    8,   32,    8,   34,    8,   36,    8,   38,    8,
   40,    8,   42,    8,   44,    8,   46,    8,   48,    8,
   50,    8,   52,    8,   54,    8,   56,    8,   58,    8,
   60,    8,   62,    8,   64,    8,   66,    8,   68,    8,
   11,   11,   11,   11,   11,   11,    4,    4,   13,   69,
   69,   69,   69,   71,   69,   72,   72,   70,   70,   70,
   70,   70,   70,   70,   70,   70,   70,   70,   70,   70,
   70,   70,   70,   70,   70,   70,   70,   15,   17,   17,
   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,
   17,   17,   17,   17,   17,   17,   19,   19,   19,   19,
   73,   73,   73,   75,   75,   76,   76,   77,   77,   74,
   74,   21,   78,   78,   78,   78,   23,   79,   79,   79,
   79,   25,   25,   27,   27,   29,   31,   33,   33,   35,
   35,   37,   39,   39,   39,   39,   39,   41,   43,   80,
   45,   81,   45,   82,   45,   83,   45,   84,   45,   85,
   45,   86,   45,   87,   45,   88,   45,   89,   45,   90,
   45,   91,   45,   92,   45,   93,   45,   94,   45,   95,
   45,   47,   47,   96,   96,   96,   96,   49,   51,   51,
   53,   53,   55,   55,   57,   57,   59,   61,   61,   61,
   61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
   61,   61,   61,   61,   61,   61,   61,   61,   65,   65,
   63,   67,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    2,    2,    3,    3,    3,
    3,
};
short yylen[] = {                                         2,
    0,    2,    2,    2,    2,    2,    2,    1,    0,    1,
    3,    1,    0,    2,    0,    2,    0,    2,    0,    2,
    0,    2,    0,    2,    0,    2,    0,    2,    0,    2,
    0,    2,    0,    2,    0,    2,    0,    2,    0,    2,
    0,    2,    0,    2,    0,    2,    0,    2,    0,    2,
    0,    2,    0,    2,    0,    2,    0,    2,    0,    2,
    0,    2,    0,    2,    0,    2,    0,    2,    0,    2,
    1,    2,    3,    4,    2,    2,    1,    1,    2,    0,
    1,    1,    2,    0,    4,    0,    1,    1,    1,    1,
    2,    2,    2,    3,    4,    4,    4,    3,    3,    3,
    4,    4,    4,    5,    6,    6,    6,    1,    3,    4,
    3,    4,    5,    5,    1,    1,    1,    1,    1,    1,
    1,    1,    2,    2,    2,    2,    1,    2,    2,    3,
    1,    6,    1,    0,    2,    0,    2,    0,    2,    2,
    2,    2,    1,    3,    3,    5,    1,    1,    1,    2,
    2,    1,    2,    1,    2,    2,    2,    1,    2,    1,
    2,    1,    2,    2,    1,    1,    2,    2,    1,    0,
    3,    0,    3,    0,    3,    0,    3,    0,    3,    0,
    5,    0,    4,    0,    3,    0,    3,    0,    3,    0,
    3,    0,    3,    0,    3,    0,    5,    0,    4,    0,
    3,    1,    2,    1,    3,    3,    5,    2,    1,    2,
    1,    2,    1,    2,    1,    2,    1,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    2,    2,
    1,    2,    1,    1,    1,    1,    3,    1,    2,    3,
    2,    2,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    4,    4,    3,    2,    1,
    0,
};
short yydefred[] = {                                      0,
    0,    0,    0,    0,    0,    0,   10,    0,  246,    0,
    0,    0,  248,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    2,  243,    0,
    0,  249,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    3,    4,    5,    6,    7,    0,    0,    0,   14,    0,
   16,  108,   18,    0,  115,  116,  117,  118,  119,  120,
  121,  122,    0,    0,    0,    0,   20,    0,   22,    0,
   24,  147,   26,    0,   28,    0,   30,    0,   32,    0,
   34,    0,   36,    0,   38,  162,   40,    0,    0,  165,
  166,    0,   42,    0,   44,  169,   46,   48,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  202,    0,   50,    0,   52,    0,
   54,    0,   56,    0,   58,    0,   60,  217,   62,    0,
  228,  227,  229,  230,  231,  232,  234,  233,  235,  236,
  237,  238,    0,    0,    0,    0,    0,    0,    0,   64,
  241,   66,    0,    0,   68,    0,   70,  247,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   78,   77,    0,
    0,    0,    0,    0,    0,    0,   89,   88,   90,    0,
    0,    0,    0,  123,  124,  125,  126,    0,  131,    0,
    0,    0,    0,  129,    0,  143,    0,  153,    0,    0,
    0,  159,  161,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  204,    0,    0,    0,    0,    0,
    0,  219,  218,  222,  221,  223,  224,  225,  226,    0,
  239,    0,    0,    0,  277,  276,    8,    0,    0,    0,
   91,    0,    0,   93,    0,   92,    0,   84,   87,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  130,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   94,    0,    0,    0,    0,
    0,   99,   98,  100,    0,    0,    0,    0,    0,    0,
  144,    0,  145,    0,    0,    0,    0,  205,    0,  206,
   95,   97,   96,    0,    0,  101,    0,  103,    0,  102,
    0,  114,  113,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  104,    0,    0,    0,  146,  207,  105,  107,
  106,    0,    0,  132,    0,
};
short yydgoto[] = {                                      11,
  199,   13,  200,  230,   14,   15,   16,   17,   18,  309,
   89,   19,   91,   20,   93,   21,  107,   22,  109,   23,
  111,   24,  113,   25,  115,   26,  117,   27,  119,   28,
  121,   29,  123,   30,  125,   31,  127,   32,  133,   33,
  135,   34,  137,   35,  138,   36,  157,   37,  159,   38,
  161,   39,  163,   40,  165,   41,  167,   42,  169,   43,
  190,   44,  192,   45,  195,   46,  197,   47,  240,  241,
  357,  320,  253,  254,  395,  406,  414,  257,    0,  139,
  140,  141,  142,  143,  144,  145,  146,  147,  148,  149,
  150,  151,  152,  153,  154,  286,
};
short yysindex[] = {                                   -187,
 -216,  389,  389,  389,  389, -190,    0, -159,    0, -108,
    0, 1468,    0, -127,  -98,  -93,  -33,  -29, -295,  -97,
  -64,  393,  -80,  -72,  -61,  -42,  -56,  -50,  -38,  -30,
  -22,  -15,  -44,  -26,  -25,    0, -268,  -39,  -48,  -37,
  -57,   14,  -41, 1430,   11,  -86,   10,    0,    0,   79,
   79,    0, 1435,  389,  389,  389,  389,  389,  389,  389,
  389,  389,  389,  389,  389,  389,  389,  389,  389,  389,
  389,  389,  389,  389,  389,  389,  389,  389,  389,  389,
    0,    0,    0,    0,    0,  389, -188,  389,    0,  541,
    0,    0,    0,  -79,    0,    0,    0,    0,    0,    0,
    0,    0,   71,   72,   73,   74,    0,  -59,    0, -282,
    0,    0,    0,   75,    0,  389,    0,  389,    0,  389,
    0,   82,    0,   88,    0,    0,    0,  389,  389,    0,
    0,  389,    0,  389,    0,    0,    0,    0,   19,   26,
   47,   25,   49,   61,   60,   85,   86,   59,   83,   92,
   84,   81,   90,  116,    0, -217,    0,  541,    0,  389,
    0,  389,    0,  389,    0,  389,    0,    0,    0,  -45,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  209,  210,  211,  212,  214,  219,  389,    0,
    0,    0, -188,  389,    0,  389,    0,    0, 1468, -248,
 -214, 1468, 1518, 1518, 1541,  152,  152,  152,  152,  152,
  152,  152,  152,  152,  152,  152,  152, -185, -185,  191,
  191,   79,   79,   79,   79,   79, 1468,    0,    0,    9,
 1468, -212,  550, -208, -186,  223,    0,    0,    0,  231,
  244,  257,  281,    0,    0,    0,    0, -219,    0,  389,
  389, 1468,  -47,    0,  226,    0,  246,    0, 1468, 1468,
 1468,    0,    0, 1468, 1468, 1468, 1468,  541,  541,  541,
  541,  541,  389,  228,  541,  541,  541,  541,  541,  541,
  389,  229,  541,  230,    0,  246,  231, 1468, 1468, 1468,
 1468,    0,    0,    0,    0,    0,    0,    0,    0, 1468,
    0, 1468, 1468,  389,    0,    0,    0, 1468,  389,  232,
    0,  244,  233,    0,  234,    0,  236,    0,    0,  866,
  389,  389,  243,  389,  389,  243,  389, 1468, 1468,    0,
  242,  -54,  231,  231,  231,  231,  231, -215,  541,  231,
  231,  231,  231,  231,  231,  806,  541,  231,  247,  -40,
 1468, 1468,  249,  253,  255,    0,  550, -130,  -75,  -62,
  239,    0,    0,    0,  243, 1435,    3,  243,    7, 1396,
    0,  263,    0,  541,  231,  541,  231,    0,  268,    0,
    0,    0,    0,  244,  269,    0,  270,    0,  271,    0,
  258,    0,    0,  389,  248,  277,  231,  231,  279,  290,
  293,  295,    0, 1468,  389,  275,    0,    0,    0,    0,
    0, 1468,  389,    0, 1468,
};
short yyrindex[] = {                                      1,
 1494,    0,    0,    0,    0, -247,    0, -128,    0,    0,
    0,  296,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1478,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  179,
  360,    0,    0,   12,   12,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  298,    0,    0,    0,  -16,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  319,    0,    0,
    0,    0,    0,  321,    0,  322,    0,    0,    0,    0,
    0,  323,    0,  324,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  -16,    0,  353,
    0,  354,    0,  355,    0,  356,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  -65,    0,
    0,  362, 1014, 1182,  -73,  852,  902,  933,  983, 1020,
 1070, 1101, 1151, 1188, 1238, 1269, 1319,  688,  775,  -94,
  329,  489,  520,  607,  638,  725,  363,    0,    0,  365,
  366,    0,   -8,    0,    0,    0,    0,    0,    0,  367,
  283,   -7,   -7,    0,    0,    0,    0, 1350,    0,    0,
    0, -126,  368,    0,    0,    0,  369,    0,  373,  380,
  383,    0,    0,  384,  386,  397,  398,  -16,  -16,  -16,
  -16,  -16,    0,    0,  -16,  -16,  -16,  -16,  -16,  -16,
    0,    0,  -16,    0,    0,  399,  400,  407,  408,  409,
  410,    0,    0,    0,    0,    0,    0,    0,    0,  411,
    0,  415,  416,  -34,    0,    0,    0,  417,    0,    0,
    0,  391,    0,    0,    0,    0,    0,    0,    0,    0,
   -7,   12,  428,   -7,   12,  436,    0,  437,  438,    0,
    0,    0,  439,  441,  442,  448,  449,    0,  -16,  452,
  454,  455,  457,  482,  483,    0,  -16,  484,    0,    0,
  -23,  485,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  487,  421,    0,  513,    0, -254,
    0,    0,    0,  -16,  515,  -16,  516,    0,    0,    0,
    0,    0,    0,  446,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, -134,    0,  518,  521,    0,    0,
    0,    0,    0, -222,    0,  -92,    0,    0,    0,    0,
    0, -105,    0,    0,  -84,
};
short yygindex[] = {                                      0,
  418,    0,  -55,  616,    0,    0,    0,    0,    0, -252,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, -156, -229,
    0,    0,    0,  558,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,
};
#define YYTABLESIZE 1861
short yytable[] = {                                     201,
    1,  287,  255,  312,  332,   86,   87,   88,  256,  245,
  245,  245,  245,  245,  245,  245,  245,  245,  245,  245,
  245,  245,  245,  245,  245,  245,  245,  245,  245,  245,
  245,  245,  134,  350,  245,  304,  245,  305,  245,  245,
  327,   57,   58,   59,   60,   61,   62,   63,   64,   65,
   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,
   76,   77,   78,   79,  135,   55,   80,  284,    1,  304,
   48,  306,  310,  285,  134,  134,  313,  134,  134,  311,
  245,  245,  245,  314,  245,  245,    2,    3,   74,   75,
   76,   77,   78,   79,   54,    4,   80,    5,  315,  228,
    6,    7,  229,    8,    9,  316,  135,  135,   10,  135,
  135,  333,  334,  335,  336,  337,  155,  156,  340,  341,
  342,  343,  344,  345,  245,   55,  348,  384,  244,  244,
  244,  244,  244,  244,  244,  244,  244,  244,  244,  244,
  244,  244,  244,  244,  244,  244,  244,  244,  244,  244,
  244,   56,  136,  244,  385,  244,  374,  244,  244,   81,
  133,  386,  257,  257,  257,  257,  257,  257,  257,  257,
  257,  257,  257,  257,  257,  257,  257,  257,  257,  257,
  257,  137,  375,  273,  273,  273,  323,  326,   82,  257,
  377,  257,  257,   83,  138,  136,   49,  136,  136,  244,
  244,  244,  139,  244,  244,  133,  133,   90,  242,  387,
  273,  243,  273,  273,    2,    3,  388,  397,  280,  398,
  280,  280,  389,    4,  137,    5,  137,  137,    6,  390,
  372,  248,    9,  257,  257,  257,  373,  257,  257,  138,
  138,   92,  292,  244,  379,  293,  108,  139,  139,  279,
  380,  279,  279,   84,  273,  273,  273,   85,  273,  273,
  278,  110,  278,  278,   49,  365,  367,   80,  368,  369,
   80,  249,  250,  251,  112,   81,  281,  257,   81,  281,
  307,  116,    2,    3,  250,  251,  304,    9,  392,  118,
  304,    4,  393,    5,  114,  281,    6,  281,  273,    8,
    9,   13,   13,   13,  120,   15,   17,   19,  128,  129,
  130,  131,  132,  122,   19,   19,   19,   19,   19,   19,
   19,   19,  124,   19,   19,   19,   19,   21,  193,  194,
  126,  134,  164,  136,   23,   59,   25,   27,   29,  160,
   31,   69,   65,   33,   35,   37,   39,  158,  166,  168,
  196,  162,  191,   41,   41,   41,   41,   41,   43,   45,
   80,  244,  245,  246,  247,  258,   47,   47,   47,   47,
   47,   47,  262,   47,   47,   47,   47,   47,  263,   47,
   47,   47,   47,   47,  268,   49,   49,   51,   53,   55,
   57,   61,  269,  271,   63,   63,   63,   63,   63,   63,
   63,   63,   63,   63,   63,   63,   63,   63,   63,   63,
   63,   63,   63,   63,  270,   67,   67,   12,  272,   50,
   51,   52,   53,   72,   73,   74,   75,   76,   77,   78,
   79,  273,  274,   80,  277,  251,  251,  251,  251,  251,
  251,  251,  251,  251,  251,  251,  251,  251,  251,  251,
  251,  251,  251,  251,  251,  251,  251,  251,  275,  278,
  276,  281,  251,  280,  251,  251,   76,   77,   78,   79,
  279,  282,   80,  202,  203,  204,  205,  206,  207,  208,
  209,  210,  211,  212,  213,  214,  215,  216,  217,  218,
  219,  220,  221,  222,  223,  224,  225,  226,  283,  294,
  295,  296,  297,  227,  298,  231,  251,  251,  251,  299,
  251,  251,   49,  317,  318,  319,  331,  307,  339,  347,
  349,  356,  353,  354,  355,  252,  304,  371,  321,  391,
    2,    3,  378,  259,  381,  260,   49,  261,  382,    4,
  383,  322,   86,  403,    6,  264,  265,    8,    9,  266,
  251,  267,  324,  396,    2,    3,   86,   86,  399,  400,
  401,  402,  407,    4,  408,  325,   82,   86,    6,   82,
   86,    8,    9,   86,   86,  409,  405,  288,  410,  289,
  411,  290,   12,  291,   71,  258,  258,  258,  258,  258,
  258,  258,  258,  258,  258,  258,  258,  258,  258,  258,
  258,  258,  258,  258,  413,  127,  300,  152,  154,  158,
  160,  302,  258,  303,  258,  258,  252,  252,  252,  252,
  252,  252,  252,  252,  252,  252,  252,  252,  252,  252,
  252,  252,  252,  252,  252,  252,  252,  252,  252,  209,
  211,  213,  215,  252,   49,  252,  252,  308,   11,   76,
   86,   72,   75,   79,  128,  142,  258,  258,  258,  155,
  258,  258,    2,    3,   86,   86,  156,  328,  329,  157,
  163,    4,  164,    5,   83,   86,    6,   83,   86,    8,
    9,   86,   86,  167,  168,  203,  208,  252,  252,  252,
  338,  252,  252,  210,  212,  214,  216,  220,  346,   94,
  258,  240,  242,   73,  280,   86,   95,   96,   97,   98,
   99,  100,  101,  102,  111,  103,  104,  105,  106,   86,
   86,  351,  109,  140,  141,  171,  352,  173,  175,   85,
   86,  252,   85,   86,  177,  179,   86,   86,  185,  366,
  187,  189,  366,  191,  370,  254,  254,  254,  254,  254,
  254,  254,  254,  254,  254,  254,  254,  254,  254,  254,
  254,  254,  254,  254,  254,  254,  254,  254,  193,  195,
  201,   74,  254,  112,  254,  254,  255,  255,  255,  255,
  255,  255,  255,  255,  255,  255,  255,  255,  255,  255,
  255,  255,  255,  255,  255,  255,  255,  255,  255,  110,
  232,  183,  199,  255,  181,  255,  255,  197,  301,  232,
  330,  404,  233,    0,  234,  235,  254,  254,  254,    0,
  254,  254,  412,  234,  235,  236,    0,    0,  237,    0,
  415,  238,  239,    0,  236,    0,    0,  237,    0,    0,
  238,  239,    0,    0,    0,    0,    0,  255,  255,  255,
    0,  255,  255,    0,    0,    0,    0,    0,    0,    0,
  254,    0,    0,  256,  256,  256,  256,  256,  256,  256,
  256,  256,  256,  256,  256,  256,  256,  256,  256,  256,
  256,  256,  256,  256,  256,  256,    0,    0,    0,    0,
  256,  255,  256,  256,  253,  253,  253,  253,  253,  253,
  253,  253,  253,  253,  253,  253,  253,  253,  253,  253,
  253,  253,  253,  253,  253,  253,  253,    0,    0,    0,
    0,  253,    0,  253,  253,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  256,  256,  256,    0,  256,  256,
    0,    0,    0,    0,  259,  259,  259,  259,  259,  259,
  259,  259,  259,  259,  259,  259,  259,  259,  259,  259,
  259,    0,    0,    0,    0,  253,  253,  253,    0,  253,
  253,  259,    0,  259,  259,    0,    0,    0,  256,    0,
    0,  250,  250,  250,  250,  250,  250,  250,  250,  250,
  250,  250,  250,  250,  250,  250,  250,  250,  250,  250,
  250,  250,  250,  250,    0,    0,    0,    0,  250,  253,
  250,  250,    0,    0,    0,  259,  259,  259,    0,  259,
  259,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  260,  260,  260,  260,  260,  260,  260,  260,  260,
  260,  260,  260,  260,  260,  260,  260,  260,    0,    0,
    0,    0,  250,  250,  250,    0,  250,  250,  260,  259,
  260,  260,   57,   58,   59,   60,   61,   62,   63,   64,
   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,
   75,   76,   77,   78,   79,    0,    0,   80,    0,    0,
    0,    0,    0,    0,    0,    0,  250,    0,    0,    0,
    0,    0,  260,  260,  260,    0,  260,  260,  261,  261,
  261,  261,  261,  261,  261,  261,  261,  261,  261,  261,
  261,  261,  261,    0,    0,  358,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  261,    0,  261,  261,  359,
  360,    0,    0,    0,    0,    0,  260,    0,    0,    0,
  361,    0,    0,  362,    0,    0,  363,  364,  264,  264,
  264,  264,  264,  264,  264,  264,  264,  264,  264,  264,
  264,  264,  264,    0,    0,    0,    0,  376,    0,  261,
  261,  261,    0,  261,  261,  264,    0,  264,  264,  266,
  266,  266,  266,  266,  266,  266,  266,  266,  266,  266,
  266,  266,  266,  266,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  266,    0,  266,  266,
    0,    0,    0,  261,    0,    0,    0,    0,    0,  264,
  264,  264,    0,  264,  264,    0,    0,    0,    0,  263,
  263,  263,  263,  263,  263,  263,  263,  263,  263,  263,
  263,  263,  263,  263,    0,    0,    0,    0,    0,    0,
  266,  266,  266,    0,  266,  266,  263,    0,  263,  263,
  274,  274,    0,  264,    0,    0,  265,  265,  265,  265,
  265,  265,  265,  265,  265,  265,  265,  265,  265,  265,
  265,    0,    0,    0,    0,    0,    0,  274,    0,  274,
  274,    0,    0,  265,  266,  265,  265,    0,    0,    0,
  263,  263,  263,    0,  263,  263,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  262,  262,  262,  262,
  262,  262,  262,  262,  262,  262,  262,  262,  262,  262,
  262,  274,  274,  274,    0,  274,  274,  265,  265,  265,
    0,  265,  265,  262,  263,  262,  262,  267,  267,  267,
  267,  267,  267,  267,  267,  267,  267,  267,  267,  267,
  267,  267,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  267,  274,  267,  267,    0,    0,
    0,  265,    0,    0,    0,    0,    0,  262,  262,  262,
    0,  262,  262,    0,    0,    0,    0,  268,  268,  268,
  268,  268,  268,  268,  268,  268,  268,  268,  268,  268,
  268,  268,    0,    0,    0,    0,    0,    0,  267,  267,
  267,    0,  267,  267,  268,    0,  268,  268,  275,  275,
    0,  262,    0,    0,  270,  270,  270,  270,  270,  270,
  270,  270,  270,  270,  270,  270,  270,  270,  270,    0,
    0,    0,    0,    0,    0,  275,    0,  275,  275,    0,
    0,  270,  267,  270,  270,    0,    0,    0,  268,  268,
  268,    0,  268,  268,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  272,  272,  272,  272,  272,  272,
  272,  272,  272,  272,  272,  272,  272,  272,  272,  275,
  275,  275,    0,  275,  275,  270,  270,  270,    0,  270,
  270,  272,  268,  272,  272,  269,  269,  269,  269,  269,
  269,  269,  269,  269,  269,  269,  269,  269,  269,  269,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  269,  275,  269,  269,    0,    0,    0,  270,
    0,    0,    0,    0,    0,  272,  272,  272,    0,  272,
  272,    0,    0,    0,    0,  271,  271,  271,  271,  271,
  271,  271,  271,  271,  271,  271,  271,  271,  271,  271,
    0,    0,    0,    0,    0,    0,  269,  269,  269,    0,
  269,  269,  271,    0,  271,  271,  244,  244,  244,  272,
  244,  244,  244,  244,  244,  244,  244,  244,  244,  244,
  244,  244,  244,  244,  244,  244,  244,  244,  244,    0,
    0,  244,    0,    0,    0,    0,  244,    0,    0,    0,
  269,    0,    0,    0,    0,    0,  271,  271,  271,    0,
  271,  271,   57,   58,   59,   60,   61,   62,   63,   64,
   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,
   75,   76,   77,   78,   79,    0,    0,   80,    0,    0,
    0,  244,  244,    0,    0,    0,    0,    0,    0,    0,
  271,   57,   58,   59,   60,   61,   62,   63,   64,   65,
   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,
   76,   77,   78,   79,    0,    0,   80,    0,    0,    0,
  198,    0,    0,  394,   57,   58,   59,   60,   61,   62,
   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,
   73,   74,   75,   76,   77,   78,   79,    0,    0,   80,
  243,  243,  243,  243,  243,  243,  243,  243,  243,  243,
  243,  243,  243,  243,  243,  243,  243,  243,  243,  243,
  243,  243,  243,    0,    0,  243,   59,   60,   61,   62,
   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,
   73,   74,   75,   76,   77,   78,   79,    0,    0,   80,
   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,
   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,
    0,    0,   80,  170,  171,  172,  173,  174,  175,  176,
  177,  178,  179,  180,  181,  182,  183,  184,  185,  186,
  187,  188,  189,  170,  172,  174,  176,  178,  180,    0,
  182,  184,  186,  188,  190,    0,  192,  194,  196,  198,
  200,
};
short yycheck[] = {                                      55,
    0,  158,  285,  233,  257,  301,  302,  303,  291,  257,
  258,  259,  260,  261,  262,  263,  264,  265,  266,  267,
  268,  269,  270,  271,  272,  273,  274,  275,  276,  277,
  278,  279,  287,  286,  282,  284,  284,  286,  286,  287,
  260,  257,  258,  259,  260,  261,  262,  263,  264,  265,
  266,  267,  268,  269,  270,  271,  272,  273,  274,  275,
  276,  277,  278,  279,  287,  285,  282,  285,  256,  284,
  287,  286,  285,  291,  329,  330,  285,  332,  333,  292,
  328,  329,  330,  292,  332,  333,  274,  275,  274,  275,
  276,  277,  278,  279,  285,  283,  282,  285,  285,  288,
  288,  289,  291,  291,  292,  292,  329,  330,  296,  332,
  333,  268,  269,  270,  271,  272,  385,  386,  275,  276,
  277,  278,  279,  280,  372,  285,  283,  357,  257,  258,
  259,  260,  261,  262,  263,  264,  265,  266,  267,  268,
  269,  270,  271,  272,  273,  274,  275,  276,  277,  278,
  279,  260,  287,  282,  285,  284,  372,  286,  287,  287,
  287,  292,  257,  258,  259,  260,  261,  262,  263,  264,
  265,  266,  267,  268,  269,  270,  271,  272,  273,  274,
  275,  287,  339,  257,  258,  259,  242,  243,  287,  284,
  347,  286,  287,  287,  287,  330,  256,  332,  333,  328,
  329,  330,  287,  332,  333,  332,  333,  305,  288,  285,
  284,  291,  286,  287,  274,  275,  292,  374,  284,  376,
  286,  287,  285,  283,  330,  285,  332,  333,  288,  292,
  285,  291,  292,  328,  329,  330,  291,  332,  333,  332,
  333,  306,  288,  372,  285,  291,  327,  332,  333,  284,
  291,  286,  287,  287,  328,  329,  330,  287,  332,  333,
  284,  334,  286,  287,  256,  321,  322,  284,  324,  325,
  287,  331,  332,  333,  336,  284,  284,  372,  287,  287,
  272,  338,  274,  275,  332,  333,  284,  287,  286,  340,
  284,  283,  286,  285,  337,  284,  288,  286,  372,  291,
  292,  301,  302,  303,  343,  305,  306,  307,  353,  354,
  355,  356,  357,  344,  314,  315,  316,  317,  318,  319,
  320,  321,  345,  323,  324,  325,  326,  327,  415,  416,
  346,  358,  390,  359,  334,  335,  336,  337,  338,  388,
  340,  341,  342,  343,  344,  345,  346,  387,  335,  391,
  341,  389,  342,  353,  354,  355,  356,  357,  358,  359,
  282,  291,  291,  291,  291,  291,  366,  367,  368,  369,
  370,  371,  291,  373,  374,  375,  376,  377,  291,  379,
  380,  381,  382,  383,  366,  385,  386,  387,  388,  389,
  390,  391,  367,  369,  394,  395,  396,  397,  398,  399,
  400,  401,  402,  403,  404,  405,  406,  407,  408,  409,
  410,  411,  412,  413,  368,  415,  416,    0,  370,    2,
    3,    4,    5,  272,  273,  274,  275,  276,  277,  278,
  279,  371,  373,  282,  376,  257,  258,  259,  260,  261,
  262,  263,  264,  265,  266,  267,  268,  269,  270,  271,
  272,  273,  274,  275,  276,  277,  278,  279,  374,  377,
  375,  381,  284,  380,  286,  287,  276,  277,  278,  279,
  379,  382,  282,   56,   57,   58,   59,   60,   61,   62,
   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,
   73,   74,   75,   76,   77,   78,   79,   80,  383,  291,
  291,  291,  291,   86,  291,   88,  328,  329,  330,  291,
  332,  333,  256,  291,  284,  272,  291,  272,  291,  291,
  291,  286,  291,  291,  291,  108,  284,  286,  272,  291,
  274,  275,  286,  116,  286,  118,  256,  120,  286,  283,
  286,  285,  260,  286,  288,  128,  129,  291,  292,  132,
  372,  134,  272,  291,  274,  275,  274,  275,  291,  291,
  291,  291,  286,  283,  286,  285,  284,  285,  288,  287,
  288,  291,  292,  291,  292,  286,  329,  160,  286,  162,
  286,  164,  287,  166,  287,  257,  258,  259,  260,  261,
  262,  263,  264,  265,  266,  267,  268,  269,  270,  271,
  272,  273,  274,  275,  330,  287,  189,  287,  287,  287,
  287,  194,  284,  196,  286,  287,  257,  258,  259,  260,
  261,  262,  263,  264,  265,  266,  267,  268,  269,  270,
  271,  272,  273,  274,  275,  276,  277,  278,  279,  287,
  287,  287,  287,  284,  256,  286,  287,  230,  287,  287,
  260,  287,  287,  287,  287,  287,  328,  329,  330,  287,
  332,  333,  274,  275,  274,  275,  287,  250,  251,  287,
  287,  283,  287,  285,  284,  285,  288,  287,  288,  291,
  292,  291,  292,  287,  287,  287,  287,  328,  329,  330,
  273,  332,  333,  287,  287,  287,  287,  287,  281,  307,
  372,  287,  287,  287,  284,  260,  314,  315,  316,  317,
  318,  319,  320,  321,  287,  323,  324,  325,  326,  274,
  275,  304,  287,  287,  287,  287,  309,  287,  287,  284,
  285,  372,  287,  288,  287,  287,  291,  292,  287,  322,
  287,  287,  325,  287,  327,  257,  258,  259,  260,  261,
  262,  263,  264,  265,  266,  267,  268,  269,  270,  271,
  272,  273,  274,  275,  276,  277,  278,  279,  287,  287,
  287,  287,  284,  287,  286,  287,  257,  258,  259,  260,
  261,  262,  263,  264,  265,  266,  267,  268,  269,  270,
  271,  272,  273,  274,  275,  276,  277,  278,  279,  287,
  260,  287,  287,  284,  287,  286,  287,  287,  193,  260,
  253,  394,  272,   -1,  274,  275,  328,  329,  330,   -1,
  332,  333,  405,  274,  275,  285,   -1,   -1,  288,   -1,
  413,  291,  292,   -1,  285,   -1,   -1,  288,   -1,   -1,
  291,  292,   -1,   -1,   -1,   -1,   -1,  328,  329,  330,
   -1,  332,  333,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  372,   -1,   -1,  257,  258,  259,  260,  261,  262,  263,
  264,  265,  266,  267,  268,  269,  270,  271,  272,  273,
  274,  275,  276,  277,  278,  279,   -1,   -1,   -1,   -1,
  284,  372,  286,  287,  257,  258,  259,  260,  261,  262,
  263,  264,  265,  266,  267,  268,  269,  270,  271,  272,
  273,  274,  275,  276,  277,  278,  279,   -1,   -1,   -1,
   -1,  284,   -1,  286,  287,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  328,  329,  330,   -1,  332,  333,
   -1,   -1,   -1,   -1,  257,  258,  259,  260,  261,  262,
  263,  264,  265,  266,  267,  268,  269,  270,  271,  272,
  273,   -1,   -1,   -1,   -1,  328,  329,  330,   -1,  332,
  333,  284,   -1,  286,  287,   -1,   -1,   -1,  372,   -1,
   -1,  257,  258,  259,  260,  261,  262,  263,  264,  265,
  266,  267,  268,  269,  270,  271,  272,  273,  274,  275,
  276,  277,  278,  279,   -1,   -1,   -1,   -1,  284,  372,
  286,  287,   -1,   -1,   -1,  328,  329,  330,   -1,  332,
  333,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  257,  258,  259,  260,  261,  262,  263,  264,  265,
  266,  267,  268,  269,  270,  271,  272,  273,   -1,   -1,
   -1,   -1,  328,  329,  330,   -1,  332,  333,  284,  372,
  286,  287,  257,  258,  259,  260,  261,  262,  263,  264,
  265,  266,  267,  268,  269,  270,  271,  272,  273,  274,
  275,  276,  277,  278,  279,   -1,   -1,  282,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  372,   -1,   -1,   -1,
   -1,   -1,  328,  329,  330,   -1,  332,  333,  257,  258,
  259,  260,  261,  262,  263,  264,  265,  266,  267,  268,
  269,  270,  271,   -1,   -1,  260,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  284,   -1,  286,  287,  274,
  275,   -1,   -1,   -1,   -1,   -1,  372,   -1,   -1,   -1,
  285,   -1,   -1,  288,   -1,   -1,  291,  292,  257,  258,
  259,  260,  261,  262,  263,  264,  265,  266,  267,  268,
  269,  270,  271,   -1,   -1,   -1,   -1,  372,   -1,  328,
  329,  330,   -1,  332,  333,  284,   -1,  286,  287,  257,
  258,  259,  260,  261,  262,  263,  264,  265,  266,  267,
  268,  269,  270,  271,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  284,   -1,  286,  287,
   -1,   -1,   -1,  372,   -1,   -1,   -1,   -1,   -1,  328,
  329,  330,   -1,  332,  333,   -1,   -1,   -1,   -1,  257,
  258,  259,  260,  261,  262,  263,  264,  265,  266,  267,
  268,  269,  270,  271,   -1,   -1,   -1,   -1,   -1,   -1,
  328,  329,  330,   -1,  332,  333,  284,   -1,  286,  287,
  257,  258,   -1,  372,   -1,   -1,  257,  258,  259,  260,
  261,  262,  263,  264,  265,  266,  267,  268,  269,  270,
  271,   -1,   -1,   -1,   -1,   -1,   -1,  284,   -1,  286,
  287,   -1,   -1,  284,  372,  286,  287,   -1,   -1,   -1,
  328,  329,  330,   -1,  332,  333,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,  259,  260,
  261,  262,  263,  264,  265,  266,  267,  268,  269,  270,
  271,  328,  329,  330,   -1,  332,  333,  328,  329,  330,
   -1,  332,  333,  284,  372,  286,  287,  257,  258,  259,
  260,  261,  262,  263,  264,  265,  266,  267,  268,  269,
  270,  271,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  284,  372,  286,  287,   -1,   -1,
   -1,  372,   -1,   -1,   -1,   -1,   -1,  328,  329,  330,
   -1,  332,  333,   -1,   -1,   -1,   -1,  257,  258,  259,
  260,  261,  262,  263,  264,  265,  266,  267,  268,  269,
  270,  271,   -1,   -1,   -1,   -1,   -1,   -1,  328,  329,
  330,   -1,  332,  333,  284,   -1,  286,  287,  257,  258,
   -1,  372,   -1,   -1,  257,  258,  259,  260,  261,  262,
  263,  264,  265,  266,  267,  268,  269,  270,  271,   -1,
   -1,   -1,   -1,   -1,   -1,  284,   -1,  286,  287,   -1,
   -1,  284,  372,  286,  287,   -1,   -1,   -1,  328,  329,
  330,   -1,  332,  333,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  257,  258,  259,  260,  261,  262,
  263,  264,  265,  266,  267,  268,  269,  270,  271,  328,
  329,  330,   -1,  332,  333,  328,  329,  330,   -1,  332,
  333,  284,  372,  286,  287,  257,  258,  259,  260,  261,
  262,  263,  264,  265,  266,  267,  268,  269,  270,  271,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  284,  372,  286,  287,   -1,   -1,   -1,  372,
   -1,   -1,   -1,   -1,   -1,  328,  329,  330,   -1,  332,
  333,   -1,   -1,   -1,   -1,  257,  258,  259,  260,  261,
  262,  263,  264,  265,  266,  267,  268,  269,  270,  271,
   -1,   -1,   -1,   -1,   -1,   -1,  328,  329,  330,   -1,
  332,  333,  284,   -1,  286,  287,  257,  258,  259,  372,
  261,  262,  263,  264,  265,  266,  267,  268,  269,  270,
  271,  272,  273,  274,  275,  276,  277,  278,  279,   -1,
   -1,  282,   -1,   -1,   -1,   -1,  287,   -1,   -1,   -1,
  372,   -1,   -1,   -1,   -1,   -1,  328,  329,  330,   -1,
  332,  333,  257,  258,  259,  260,  261,  262,  263,  264,
  265,  266,  267,  268,  269,  270,  271,  272,  273,  274,
  275,  276,  277,  278,  279,   -1,   -1,  282,   -1,   -1,
   -1,  332,  333,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  372,  257,  258,  259,  260,  261,  262,  263,  264,  265,
  266,  267,  268,  269,  270,  271,  272,  273,  274,  275,
  276,  277,  278,  279,   -1,   -1,  282,   -1,   -1,   -1,
  286,   -1,   -1,  328,  257,  258,  259,  260,  261,  262,
  263,  264,  265,  266,  267,  268,  269,  270,  271,  272,
  273,  274,  275,  276,  277,  278,  279,   -1,   -1,  282,
  257,  258,  259,  260,  261,  262,  263,  264,  265,  266,
  267,  268,  269,  270,  271,  272,  273,  274,  275,  276,
  277,  278,  279,   -1,   -1,  282,  259,  260,  261,  262,
  263,  264,  265,  266,  267,  268,  269,  270,  271,  272,
  273,  274,  275,  276,  277,  278,  279,   -1,   -1,  282,
  260,  261,  262,  263,  264,  265,  266,  267,  268,  269,
  270,  271,  272,  273,  274,  275,  276,  277,  278,  279,
   -1,   -1,  282,  394,  395,  396,  397,  398,  399,  400,
  401,  402,  403,  404,  405,  406,  407,  408,  409,  410,
  411,  412,  413,  366,  367,  368,  369,  370,  371,   -1,
  373,  374,  375,  376,  377,   -1,  379,  380,  381,  382,
  383,
};
#define YYFINAL 11
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 418
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"TOK_OR","TOK_XOR","TOK_AND",
"TOK_EQUAL","TOK_GREATER_EQUAL","TOK_GREATER_THAN","TOK_LESS_EQUAL",
"TOK_LESS_THAN","TOK_NOT_EQUAL","TOK_EXACT_EQUAL","TOK_EXACT_NOT_EQUAL",
"TOK_EXACT_GREATER_EQUAL","TOK_EXACT_GREATER_THAN","TOK_EXACT_LESS_EQUAL",
"TOK_EXACT_LESS_THAN","TOK_BLANK","TOK_CONCAT","TOK_MINUS","TOK_PLUS",
"TOK_INT_DIV","TOK_REMAINDER","TOK_REAL_DIV","TOK_MULT","NEGATIVE","POSITIVE",
"TOK_EXP","TOK_NOT","TOK_COMMA","TOK_LPAREN","TOK_RPAREN","TOK_NEWLINE",
"TOK_STRING_LITERAL","TOK_LABEL","TOK_COLON","TOK_SYMBOL","TOK_FIXED",
"TOK_STEM","TOK_COMPOUND","TOK_SIMPLE","TOK_ASSIGNMENT","TOK_NULLCLAUSE",
"TOK_ERRORCLAUSE","TOK_COMMANDCLAUSE","TOK_LINENUMBER","TOK_ADDRESS",
"TOK_ADDRESS_SS","TOK_ADDRESS_VALUE","TOK_VALUE","TOK_ARG","TOK_BREAK",
"TOK_CALL","TOK_ON","TOK_OFF","TOK_FAILURE","TOK_ERROR","TOK_HALT",
"TOK_NOTREADY","TOK_CALL_ON_FAILURE","TOK_CALL_ON_ERROR","TOK_CALL_ON_HALT",
"TOK_CALL_ON_NOTREADY","TOK_CALL_OFF_FAILURE","TOK_CALL_OFF_ERROR",
"TOK_CALL_OFF_HALT","TOK_CALL_OFF_NOTREADY","TOK_NAME",
"TOK_CALL_ON_FAILURE_NAME","TOK_CALL_ON_ERROR_NAME","TOK_CALL_ON_HALT_NAME",
"TOK_CALL_ON_NOTREADY_NAME","TOK_DO","TOK_TO","TOK_BY","TOK_FOR","TOK_FOREVER",
"TOK_WHILE","TOK_UNTIL","TOK_DROP","TOK_SAY","TOK_ELSE","TOK_END","TOK_EXIT",
"TOK_EOF","TOK_IF","TOK_WHEN","TOK_THEN","TOK_INTERPRET","TOK_ITERATE",
"TOK_LEAVE","TOK_NOP","TOK_DIGITS","TOK_FUZZ","TOK_FORM","TOK_SCIENTIFIC",
"TOK_ENGINEERING","TOK_NUMERIC","TOK_NUMERIC_DIGITS","TOK_NUMERIC_FUZZ",
"TOK_NUMERIC_FORM_SCIENTIFIC","TOK_NUMERIC_FORM_ENGINEERING",
"TOK_NUMERIC_FORM_VALUE","TOK_OPTIONS","TOK_OTHERWISE","TOK_LINEIN",
"TOK_EXTERNAL","TOK_SOURCE","TOK_VAR","TOK_VERSION","TOK_PARSE","TOK_PARSE_ARG",
"TOK_PARSE_LINEIN","TOK_PARSE_EXTERNAL","TOK_PARSE_PULL","TOK_PARSE_SOURCE",
"TOK_PARSE_VALUE","TOK_WITH","TOK_PARSE_VAR","TOK_PARSE_VERSION",
"TOK_PARSE_UPPER_ARG","TOK_PARSE_UPPER_LINEIN","TOK_PARSE_UPPER_EXTERNAL",
"TOK_PARSE_UPPER_NUMERIC","TOK_PARSE_UPPER_PULL","TOK_PARSE_UPPER_SOURCE",
"TOK_PARSE_UPPER_VALUE","TOK_PARSE_UPPER_VAR","TOK_PARSE_UPPER_VERSION",
"TOK_EXPOSE","TOK_PROCEDURE","TOK_PROCEDURE_EXPOSE","TOK_PULL","TOK_PUSH",
"TOK_QUEUE","TOK_RETURN","TOK_SELECT","TOK_SYNTAX","TOK_NOVALUE","TOK_SIGNAL",
"TOK_SIGNAL_ON_FAILURE","TOK_SIGNAL_ON_ERROR","TOK_SIGNAL_ON_HALT",
"TOK_SIGNAL_ON_NOTREADY","TOK_SIGNAL_ON_NOVALUE","TOK_SIGNAL_ON_SYNTAX",
"TOK_SIGNAL_OFF_FAILURE","TOK_SIGNAL_OFF_ERROR","TOK_SIGNAL_OFF_HALT",
"TOK_SIGNAL_OFF_NOTREADY","TOK_SIGNAL_OFF_NOVALUE","TOK_SIGNAL_OFF_SYNTAX",
"TOK_SIGNAL_ON_FAILURE_NAME","TOK_SIGNAL_ON_ERROR_NAME",
"TOK_SIGNAL_ON_HALT_NAME","TOK_SIGNAL_ON_NOTREADY_NAME",
"TOK_SIGNAL_ON_NOVALUE_NAME","TOK_SIGNAL_ON_SYNTAX_NAME","TOK_SIGNAL_VALUE",
"TOK_TRACE","TOK_TRACE_SS","TOK_TRACE_VALUE","TOK_UPPER","TOK_UNKNOWN",
};
char *yyrule[] = {
"$accept : clause",
"clause :",
"clause : error TOK_NEWLINE",
"clause : null_clause TOK_NEWLINE",
"clause : label_clause TOK_NEWLINE",
"clause : assignment_clause TOK_NEWLINE",
"clause : instruction_clause TOK_NEWLINE",
"clause : command_clause TOK_NEWLINE",
"bl : TOK_BLANK",
"null_clause :",
"label_clause : TOK_LABEL",
"assignment_clause : TOK_ASSIGNMENT TOK_EQUAL expression_any",
"command_clause : expression_any",
"$$1 :",
"instruction_clause : $$1 address_instruction",
"$$2 :",
"instruction_clause : $$2 arg_instruction",
"$$3 :",
"instruction_clause : $$3 break_instruction",
"$$4 :",
"instruction_clause : $$4 call_instruction",
"$$5 :",
"instruction_clause : $$5 do_instruction",
"$$6 :",
"instruction_clause : $$6 drop_instruction",
"$$7 :",
"instruction_clause : $$7 else_instruction",
"$$8 :",
"instruction_clause : $$8 end_instruction",
"$$9 :",
"instruction_clause : $$9 exit_instruction",
"$$10 :",
"instruction_clause : $$10 if_instruction",
"$$11 :",
"instruction_clause : $$11 interpret_instruction",
"$$12 :",
"instruction_clause : $$12 iterate_instruction",
"$$13 :",
"instruction_clause : $$13 leave_instruction",
"$$14 :",
"instruction_clause : $$14 nop_instruction",
"$$15 :",
"instruction_clause : $$15 numeric_instruction",
"$$16 :",
"instruction_clause : $$16 options_instruction",
"$$17 :",
"instruction_clause : $$17 otherwise_instruction",
"$$18 :",
"instruction_clause : $$18 parse_instruction",
"$$19 :",
"instruction_clause : $$19 procedure_instruction",
"$$20 :",
"instruction_clause : $$20 pull_instruction",
"$$21 :",
"instruction_clause : $$21 push_instruction",
"$$22 :",
"instruction_clause : $$22 queue_instruction",
"$$23 :",
"instruction_clause : $$23 return_instruction",
"$$24 :",
"instruction_clause : $$24 say_instruction",
"$$25 :",
"instruction_clause : $$25 select_instruction",
"$$26 :",
"instruction_clause : $$26 signal_instruction",
"$$27 :",
"instruction_clause : $$27 then_instruction",
"$$28 :",
"instruction_clause : $$28 trace_instruction",
"$$29 :",
"instruction_clause : $$29 when_instruction",
"address_instruction : TOK_ADDRESS",
"address_instruction : TOK_ADDRESS_SS symbol_or_string",
"address_instruction : TOK_ADDRESS_SS symbol_or_string expression_any",
"address_instruction : TOK_ADDRESS_SS symbol_or_string bl expression_any",
"address_instruction : TOK_ADDRESS_VALUE expression_any",
"address_instruction : TOK_ADDRESS expression_any",
"symbol_or_string : TOK_SYMBOL",
"symbol_or_string : TOK_STRING_LITERAL",
"arg_instruction : TOK_ARG optional_template_list",
"optional_template_list :",
"optional_template_list : TOK_BLANK",
"optional_template_list : template_list",
"optional_template_list : TOK_BLANK template_list",
"$$30 :",
"optional_template_list : optional_template_list TOK_COMMA $$30 template_list",
"obl :",
"obl : TOK_BLANK",
"template_list : TOK_SYMBOL",
"template_list : TOK_STRING_LITERAL",
"template_list : TOK_FIXED",
"template_list : TOK_EQUAL TOK_FIXED",
"template_list : TOK_PLUS TOK_FIXED",
"template_list : TOK_MINUS TOK_FIXED",
"template_list : TOK_LPAREN TOK_SYMBOL TOK_RPAREN",
"template_list : TOK_EQUAL TOK_LPAREN TOK_SYMBOL TOK_RPAREN",
"template_list : TOK_PLUS TOK_LPAREN TOK_SYMBOL TOK_RPAREN",
"template_list : TOK_MINUS TOK_LPAREN TOK_SYMBOL TOK_RPAREN",
"template_list : template_list obl TOK_SYMBOL",
"template_list : template_list obl TOK_STRING_LITERAL",
"template_list : template_list obl TOK_FIXED",
"template_list : template_list obl TOK_EQUAL TOK_FIXED",
"template_list : template_list obl TOK_PLUS TOK_FIXED",
"template_list : template_list obl TOK_MINUS TOK_FIXED",
"template_list : template_list obl TOK_LPAREN TOK_SYMBOL TOK_RPAREN",
"template_list : template_list obl TOK_EQUAL TOK_LPAREN TOK_SYMBOL TOK_RPAREN",
"template_list : template_list obl TOK_PLUS TOK_LPAREN TOK_SYMBOL TOK_RPAREN",
"template_list : template_list obl TOK_MINUS TOK_LPAREN TOK_SYMBOL TOK_RPAREN",
"break_instruction : TOK_BREAK",
"call_instruction : TOK_CALL TOK_SYMBOL optional_expression_list",
"call_instruction : TOK_CALL TOK_SYMBOL TOK_BLANK optional_expression_list",
"call_instruction : TOK_CALL TOK_STRING_LITERAL optional_expression_list",
"call_instruction : TOK_CALL TOK_STRING_LITERAL TOK_BLANK optional_expression_list",
"call_instruction : TOK_CALL TOK_SYMBOL TOK_LPAREN optional_expression_list TOK_RPAREN",
"call_instruction : TOK_CALL TOK_STRING_LITERAL TOK_LPAREN optional_expression_list TOK_RPAREN",
"call_instruction : TOK_CALL_ON_FAILURE",
"call_instruction : TOK_CALL_ON_ERROR",
"call_instruction : TOK_CALL_ON_HALT",
"call_instruction : TOK_CALL_ON_NOTREADY",
"call_instruction : TOK_CALL_OFF_FAILURE",
"call_instruction : TOK_CALL_OFF_ERROR",
"call_instruction : TOK_CALL_OFF_HALT",
"call_instruction : TOK_CALL_OFF_NOTREADY",
"call_instruction : TOK_CALL_ON_FAILURE_NAME TOK_SYMBOL",
"call_instruction : TOK_CALL_ON_ERROR_NAME TOK_SYMBOL",
"call_instruction : TOK_CALL_ON_HALT_NAME TOK_SYMBOL",
"call_instruction : TOK_CALL_ON_NOTREADY_NAME TOK_SYMBOL",
"do_instruction : TOK_DO",
"do_instruction : TOK_DO do_repetitor",
"do_instruction : TOK_DO do_conditional",
"do_instruction : TOK_DO do_repetitor do_conditional",
"do_repetitor : TOK_FOREVER",
"do_repetitor : TOK_SYMBOL TOK_EQUAL expression_any do_opt_to do_opt_by do_opt_for",
"do_repetitor : expression_any",
"do_opt_to :",
"do_opt_to : TOK_TO expression_any",
"do_opt_by :",
"do_opt_by : TOK_BY expression_any",
"do_opt_for :",
"do_opt_for : TOK_FOR expression_any",
"do_conditional : TOK_WHILE expression_any",
"do_conditional : TOK_UNTIL expression_any",
"drop_instruction : TOK_DROP drop_variable_list",
"drop_variable_list : TOK_SYMBOL",
"drop_variable_list : TOK_LPAREN TOK_SYMBOL TOK_RPAREN",
"drop_variable_list : drop_variable_list bl TOK_SYMBOL",
"drop_variable_list : drop_variable_list bl TOK_LPAREN TOK_SYMBOL TOK_RPAREN",
"else_instruction : TOK_ELSE",
"separator_list : TOK_NEWLINE",
"separator_list : TOK_BLANK",
"separator_list : separator_list TOK_NEWLINE",
"separator_list : separator_list TOK_BLANK",
"end_instruction : TOK_END",
"end_instruction : TOK_END TOK_SYMBOL",
"exit_instruction : TOK_EXIT",
"exit_instruction : TOK_EXIT expression_any",
"if_instruction : TOK_IF expression_any",
"interpret_instruction : TOK_INTERPRET expression_any",
"iterate_instruction : TOK_ITERATE",
"iterate_instruction : TOK_ITERATE TOK_SYMBOL",
"leave_instruction : TOK_LEAVE",
"leave_instruction : TOK_LEAVE TOK_SYMBOL",
"nop_instruction : TOK_NOP",
"numeric_instruction : TOK_NUMERIC_DIGITS expression_any",
"numeric_instruction : TOK_NUMERIC_FUZZ expression_any",
"numeric_instruction : TOK_NUMERIC_FORM_SCIENTIFIC",
"numeric_instruction : TOK_NUMERIC_FORM_ENGINEERING",
"numeric_instruction : TOK_NUMERIC_FORM_VALUE expression_any",
"options_instruction : TOK_OPTIONS expression_any",
"otherwise_instruction : TOK_OTHERWISE",
"$$31 :",
"parse_instruction : $$31 TOK_PARSE_ARG optional_template_list",
"$$32 :",
"parse_instruction : $$32 TOK_PARSE_LINEIN optional_template_list",
"$$33 :",
"parse_instruction : $$33 TOK_PARSE_EXTERNAL optional_template_list",
"$$34 :",
"parse_instruction : $$34 TOK_PARSE_PULL optional_template_list",
"$$35 :",
"parse_instruction : $$35 TOK_PARSE_SOURCE optional_template_list",
"$$36 :",
"parse_instruction : $$36 TOK_PARSE_VALUE expression_any TOK_WITH optional_template_list",
"$$37 :",
"parse_instruction : $$37 TOK_PARSE_VAR TOK_SYMBOL optional_template_list",
"$$38 :",
"parse_instruction : $$38 TOK_PARSE_VERSION optional_template_list",
"$$39 :",
"parse_instruction : $$39 TOK_PARSE_UPPER_ARG optional_template_list",
"$$40 :",
"parse_instruction : $$40 TOK_PARSE_UPPER_LINEIN optional_template_list",
"$$41 :",
"parse_instruction : $$41 TOK_PARSE_UPPER_EXTERNAL optional_template_list",
"$$42 :",
"parse_instruction : $$42 TOK_PARSE_UPPER_PULL optional_template_list",
"$$43 :",
"parse_instruction : $$43 TOK_PARSE_UPPER_SOURCE optional_template_list",
"$$44 :",
"parse_instruction : $$44 TOK_PARSE_UPPER_VALUE expression_any TOK_WITH optional_template_list",
"$$45 :",
"parse_instruction : $$45 TOK_PARSE_UPPER_VAR TOK_SYMBOL optional_template_list",
"$$46 :",
"parse_instruction : $$46 TOK_PARSE_UPPER_VERSION optional_template_list",
"procedure_instruction : TOK_PROCEDURE",
"procedure_instruction : TOK_PROCEDURE_EXPOSE procedure_variable_list",
"procedure_variable_list : TOK_SYMBOL",
"procedure_variable_list : TOK_LPAREN TOK_SYMBOL TOK_RPAREN",
"procedure_variable_list : procedure_variable_list bl TOK_SYMBOL",
"procedure_variable_list : procedure_variable_list bl TOK_LPAREN TOK_SYMBOL TOK_RPAREN",
"pull_instruction : TOK_PULL optional_template_list",
"push_instruction : TOK_PUSH",
"push_instruction : TOK_PUSH expression_any",
"queue_instruction : TOK_QUEUE",
"queue_instruction : TOK_QUEUE expression_any",
"return_instruction : TOK_RETURN",
"return_instruction : TOK_RETURN expression_any",
"say_instruction : TOK_SAY",
"say_instruction : TOK_SAY expression_any",
"select_instruction : TOK_SELECT",
"signal_instruction : TOK_SIGNAL TOK_SYMBOL",
"signal_instruction : TOK_SIGNAL TOK_STRING_LITERAL",
"signal_instruction : TOK_SIGNAL_VALUE expression_any",
"signal_instruction : TOK_SIGNAL_ON_ERROR_NAME TOK_SYMBOL",
"signal_instruction : TOK_SIGNAL_ON_FAILURE_NAME TOK_SYMBOL",
"signal_instruction : TOK_SIGNAL_ON_HALT_NAME TOK_SYMBOL",
"signal_instruction : TOK_SIGNAL_ON_NOTREADY_NAME TOK_SYMBOL",
"signal_instruction : TOK_SIGNAL_ON_NOVALUE_NAME TOK_SYMBOL",
"signal_instruction : TOK_SIGNAL_ON_SYNTAX_NAME TOK_SYMBOL",
"signal_instruction : TOK_SIGNAL_ON_ERROR",
"signal_instruction : TOK_SIGNAL_ON_FAILURE",
"signal_instruction : TOK_SIGNAL_ON_HALT",
"signal_instruction : TOK_SIGNAL_ON_NOTREADY",
"signal_instruction : TOK_SIGNAL_ON_NOVALUE",
"signal_instruction : TOK_SIGNAL_ON_SYNTAX",
"signal_instruction : TOK_SIGNAL_OFF_ERROR",
"signal_instruction : TOK_SIGNAL_OFF_FAILURE",
"signal_instruction : TOK_SIGNAL_OFF_HALT",
"signal_instruction : TOK_SIGNAL_OFF_NOTREADY",
"signal_instruction : TOK_SIGNAL_OFF_NOVALUE",
"signal_instruction : TOK_SIGNAL_OFF_SYNTAX",
"trace_instruction : TOK_TRACE_SS symbol_or_string",
"trace_instruction : TOK_TRACE_VALUE expression_any",
"then_instruction : TOK_THEN",
"when_instruction : TOK_WHEN expression_any",
"expression_any : error",
"expression_any : TOK_SYMBOL",
"expression_any : TOK_STRING_LITERAL",
"expression_any : TOK_FIXED",
"expression_any : TOK_LPAREN expression_any TOK_RPAREN",
"expression_any : any_function_call",
"expression_any : TOK_NOT expression_any",
"expression_any : expression_any TOK_EXP expression_any",
"expression_any : TOK_MINUS expression_any",
"expression_any : TOK_PLUS expression_any",
"expression_any : expression_any TOK_MULT expression_any",
"expression_any : expression_any TOK_INT_DIV expression_any",
"expression_any : expression_any TOK_REMAINDER expression_any",
"expression_any : expression_any TOK_REAL_DIV expression_any",
"expression_any : expression_any TOK_MINUS expression_any",
"expression_any : expression_any TOK_PLUS expression_any",
"expression_any : expression_any TOK_BLANK expression_any",
"expression_any : expression_any TOK_CONCAT expression_any",
"expression_any : expression_any TOK_EQUAL expression_any",
"expression_any : expression_any TOK_NOT_EQUAL expression_any",
"expression_any : expression_any TOK_LESS_EQUAL expression_any",
"expression_any : expression_any TOK_GREATER_EQUAL expression_any",
"expression_any : expression_any TOK_LESS_THAN expression_any",
"expression_any : expression_any TOK_GREATER_THAN expression_any",
"expression_any : expression_any TOK_EXACT_EQUAL expression_any",
"expression_any : expression_any TOK_EXACT_NOT_EQUAL expression_any",
"expression_any : expression_any TOK_EXACT_LESS_EQUAL expression_any",
"expression_any : expression_any TOK_EXACT_GREATER_EQUAL expression_any",
"expression_any : expression_any TOK_EXACT_LESS_THAN expression_any",
"expression_any : expression_any TOK_EXACT_GREATER_THAN expression_any",
"expression_any : expression_any TOK_AND expression_any",
"expression_any : expression_any TOK_OR expression_any",
"expression_any : expression_any TOK_XOR expression_any",
"any_function_call : TOK_SYMBOL TOK_LPAREN optional_expression_list TOK_RPAREN",
"any_function_call : TOK_STRING_LITERAL TOK_LPAREN optional_expression_list TOK_RPAREN",
"optional_expression_list : optional_expression_list TOK_COMMA expression_any",
"optional_expression_list : optional_expression_list TOK_COMMA",
"optional_expression_list : expression_any",
"optional_expression_list :",
};
#endif
#if YYDEBUG
/* inserted by Al Villarica */
int yyhistogram[281];
int yyhistogramrule[281] = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 
17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 
33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 
49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 
65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 
81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95, 96, 
97, 98, 99, 100, 101, 102, 103, 104, 105, 106, 107, 108, 109, 110, 111, 112, 
113, 114, 115, 116, 117, 118, 119, 120, 121, 122, 123, 124, 125, 126, 127, 128, 
129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 
145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 
161, 162, 163, 164, 165, 166, 167, 168, 169, 170, 171, 172, 173, 174, 175, 176, 
177, 178, 179, 180, 181, 182, 183, 184, 185, 186, 187, 188, 189, 190, 191, 192, 
193, 194, 195, 196, 197, 198, 199, 200, 201, 202, 203, 204, 205, 206, 207, 208, 
209, 210, 211, 212, 213, 214, 215, 216, 217, 218, 219, 220, 221, 222, 223, 224, 
225, 226, 227, 228, 229, 230, 231, 232, 233, 234, 235, 236, 237, 238, 239, 240, 
241, 242, 243, 244, 245, 246, 247, 248, 249, 250, 251, 252, 253, 254, 255, 256, 
257, 258, 259, 260, 261, 262, 263, 264, 265, 266, 267, 268, 269, 270, 271, 272, 
273, 274, 275, 276, 277, 278, 279, 280, 281, };
int yymaxhistogram = 281;
#endif
#if YYDEBUG
print_histogram() {
extern int yydebug2;
int i, used = 0, kind;
  kind = yydebug2;
  printf("HISTOGRAM PRINTING\n");
  printf("0 = don't print , 1 = print used, 2 = print unused, 3 = print all\n");
  printf("Selected %d\n",yydebug2);
  for (i = 0; i < yymaxhistogram; i++) {
    if (yyhistogram[i]) used++;
    if ((kind == 1 && yyhistogram[i]) || (kind == 2 && !yyhistogram[i])
      || kind == 3)
      printf("Rule [%s] used %d time(s)\n",yyrule[yyhistogramrule[i]], yyhistogram[i]);
  }
printf("%d/%d rules used\n",used, yymaxhistogram);
}
#endif
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#ifdef YYSTACKSIZE
#ifndef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#endif
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 600
#define YYMAXDEPTH 600
#endif
#endif
int yydebug;
int yydebug2;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 859 "rexxparse.y"

int
yyerror(char* string)
{
/*
  char buf[200];

  parsererror = 1;
*/
  /*
	cout << string << " at line " << glob.LineNumber << "\n";
  */
  return 1;
}



#line 1201 "rexxparse.tab.c"
#define YYABORT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
#if YYDEBUG
#ifndef YYDEBUG_LEXER_TEXT /* pointer to the text isolated by the lexer*/
#ifdef FLEX
extern char* yytext;
#define YYDEBUG_LEXER_TEXT (yytext)
#else
#define YYDEBUG_LEXER_TEXT ("TEXT")
#endif
#endif
#ifndef YYDEBUG_INDENT_STRING
#define YYDEBUG_INDENT_STRING  "|       "
#endif
#ifndef YYDEBUG_REDUCE_STRING
#define YYDEBUG_REDUCE_STRING  "+-------"
#endif
#ifndef YYDEBUG_INDENT
YYDEBUG_INDENT(int yyindent)
{
    while(yyindent-- > 0)
        printf("%s", YYDEBUG_INDENT_STRING);
}
#endif /* YYDEBUG_INDENT */
#ifndef YYDEBUG_REDUCE
YYDEBUG_REDUCE(int yynew_state, int yyrule_num, char* yyrule_string, int yynew_indent, 
int yyrhs_count)
{
    if (1 < yyrhs_count)
    {  /* draw the graphics for the reduction */
        YYDEBUG_INDENT(yynew_indent);
        while(1 < yyrhs_count--)
            printf("%s", YYDEBUG_REDUCE_STRING);
        putchar('+'); /* left rotated L would look nice */
        putchar('\n');
        YYDEBUG_INDENT(yynew_indent);
        putchar('|'); /* down arrow would look nice */
        putchar('\n');
    }
    YYDEBUG_INDENT(yynew_indent);
    /* Only print the resulting token name */
    while (*yyrule_string && ' ' != *yyrule_string)
        putchar(*yyrule_string++);
    putchar('\n');
}
#endif /* YYDEBUG_REDUCE */
#ifndef YYDEBUG_SHIFT_LEXEME
YYDEBUG_SHIFT_LEXEME(int yyold_state, int yynew_state, char* yytoken_string, int yynew_indent)
{
    YYDEBUG_INDENT(yynew_indent);
    printf("%s <-- `%s'\n", yytoken_string, YYDEBUG_LEXER_TEXT);
}
#endif /*  YYDEBUG_SHIFT_LEXEME */
#ifndef YYDEBUG_LOOK_AHEAD
YYDEBUG_LOOK_AHEAD(int yynew_state, int yytoken_num, char* yytoken_string, int yyindent)
{
    YYDEBUG_INDENT(yyindent);
    printf("          .... look ahead at %s   `%s'\n",
           yytoken_string,
           (0 == yytoken_num)? "\0": YYDEBUG_LEXER_TEXT);
}
#endif /* YYDEBUG_LOOK_AHEAD */
#ifndef YYDEBUG_DISCARD_STATE
YYDEBUG_DISCARD_STATE(int yynew_state, int yyindent)
{
    if (0 < yyindent)
    {  /* draw the graphics for the reduction */
        YYDEBUG_INDENT(yyindent-1);
        printf("%s", YYDEBUG_REDUCE_STRING);
        putchar('+'); /* left rotated L would look nice */
        printf("  discarding state\n");
        YYDEBUG_INDENT(yyindent-1);
        putchar('|'); /* down arrow would look nice */
        putchar('\n');
    }
    else
    {
        if (0 == yyindent)
            printf("discarding state\n");
        else
            printf("no more states to discard: parser will abort\n");
    }
}
#endif /* YYDEBUG_DISCARD_STATE */
#ifndef YYDEBUG_DISCARD_TOKEN
YYDEBUG_DISCARD_TOKEN(int yynew_state, int yytoken_num, char* yytoken_string, int yyindent)
{
    YYDEBUG_INDENT(yyindent);
    printf("discarding token %s\n", yytoken_string);
}
#endif /* YYDEBUG_DISCARD_TOKEN */
#ifndef YYDEBUG_SHIFT_ERROR_LEXEME
YYDEBUG_SHIFT_ERROR_LEXEME(int yyold_state, int yynew_state, int yyindent)
{
    YYDEBUG_INDENT(yyindent);
    printf("error\n");
}
#endif /* YYDEBUG_SHIFT_ERROR_LEXEME */
#endif /* YYDEBUG */
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv(char*);

    if (yys = getenv("YYDEBUG"))
    {
        if (*yys) yyn = *yys;
        else yyn = '0';
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
        if (*yys && *(yys+1)) yyn = *(yys+1);
        else yyn = '0';
        if (yyn >= '0' && yyn <= '9')
            yydebug2 = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            if (5 > yydebug)
                printf("yydebug: state %d, reading %d (%s)\n", yystate,
                        yychar, yys);
            else if (yydebug == 6)
                YYDEBUG_LOOK_AHEAD(yystate, yychar, yys, yyssp-yyss);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            if (5 > yydebug)
                printf("yydebug: state %d, shifting to state %d\n",
                        yystate, yytable[yyn]);
            else if (yydebug == 6)
                YYDEBUG_SHIFT_LEXEME(yystate, yytable[yyn], yys, yyssp-yyss);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    if (5 > yydebug)
                        printf("yydebug: state %d, error recovery shifting\
 to state %d\n", *yyssp, yytable[yyn]);
                    else if (yydebug == 6)
                        YYDEBUG_SHIFT_ERROR_LEXEME(*yyssp, yytable[yyn], yyssp-yyss);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    if (5 > yydebug)
                        printf("yydebug: error recovery discarding state %d\n",
                            *yyssp);
                    else if (yydebug == 6)
                        YYDEBUG_DISCARD_STATE(*yyssp, yyssp-yyss-1);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            if (5 > yydebug)
                printf("yydebug: state %d, error recovery discards token %d (%s)\n",
                    yystate, yychar, yys);
            else if (yydebug == 6)
                YYDEBUG_DISCARD_TOKEN(yystate, yychar, yys, yyssp-yyss);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
#if YYDEBUG
    if (yydebug)
        if (5 > yydebug)
            printf("yydebug: state %d, reducing by rule %d (%s)\n",
                    yystate, yyn, yyrule[yyn]);
        else if (yydebug == 6)
            YYDEBUG_REDUCE(yystate, yyn, yyrule[yyn], yyssp-yyss-yym, yym);
#endif
    switch (yyn)
    {
case 1:
#if YYDEBUG
  yyhistogram[0]++;
#endif
#line 258 "rexxparse.y"
{clause = 0; YYACCEPT;}
break;
case 2:
#if YYDEBUG
  yyhistogram[1]++;
#endif
#line 259 "rexxparse.y"
{
		if (clause) {
			delete clause;
		}
		clause = new ErrorClause;
		YYACCEPT;
	}
break;
case 3:
#if YYDEBUG
  yyhistogram[2]++;
#endif
#line 266 "rexxparse.y"
{clause = new NullClause; YYACCEPT;}
break;
case 4:
#if YYDEBUG
  yyhistogram[3]++;
#endif
#line 267 "rexxparse.y"
{YYACCEPT;}
break;
case 5:
#if YYDEBUG
  yyhistogram[4]++;
#endif
#line 268 "rexxparse.y"
{YYACCEPT;}
break;
case 6:
#if YYDEBUG
  yyhistogram[5]++;
#endif
#line 269 "rexxparse.y"
{YYACCEPT;}
break;
case 7:
#if YYDEBUG
  yyhistogram[6]++;
#endif
#line 270 "rexxparse.y"
{YYACCEPT;}
break;
#if YYDEBUG
case 8:
  yyhistogram[7]++;
  break;
#endif
#if YYDEBUG
case 9:
  yyhistogram[8]++;
  break;
#endif
case 10:
#if YYDEBUG
  yyhistogram[9]++;
#endif
#line 286 "rexxparse.y"
{clause = new LabelClause(*(yyvsp[0].symbol.string));}
break;
case 11:
#if YYDEBUG
  yyhistogram[10]++;
#endif
#line 289 "rexxparse.y"
{
    clause = new AssignmentClause(*(yyvsp[-2].symbol.string), yyvsp[-2].symbol.secondary, yyvsp[0].expression);
    }
break;
case 12:
#if YYDEBUG
  yyhistogram[11]++;
#endif
#line 294 "rexxparse.y"
{clause = new CommandClause; ((CommandClause*)clause)->SetExpression(yyvsp[0].expression);}
break;
case 13:
#if YYDEBUG
  yyhistogram[12]++;
#endif
#line 297 "rexxparse.y"
{clause = new AddressClause;}
break;
#if YYDEBUG
case 14:
  yyhistogram[13]++;
  break;
#endif
case 15:
#if YYDEBUG
  yyhistogram[14]++;
#endif
#line 298 "rexxparse.y"
{clause = new ParseArgClause;}
break;
#if YYDEBUG
case 16:
  yyhistogram[15]++;
  break;
#endif
case 17:
#if YYDEBUG
  yyhistogram[16]++;
#endif
#line 299 "rexxparse.y"
{clause = new BreakClause;}
break;
#if YYDEBUG
case 18:
  yyhistogram[17]++;
  break;
#endif
case 19:
#if YYDEBUG
  yyhistogram[18]++;
#endif
#line 300 "rexxparse.y"
{clause = new CallClause;}
break;
#if YYDEBUG
case 20:
  yyhistogram[19]++;
  break;
#endif
case 21:
#if YYDEBUG
  yyhistogram[20]++;
#endif
#line 301 "rexxparse.y"
{clause = new DoClause;}
break;
#if YYDEBUG
case 22:
  yyhistogram[21]++;
  break;
#endif
case 23:
#if YYDEBUG
  yyhistogram[22]++;
#endif
#line 302 "rexxparse.y"
{clause = new DropClause;}
break;
#if YYDEBUG
case 24:
  yyhistogram[23]++;
  break;
#endif
case 25:
#if YYDEBUG
  yyhistogram[24]++;
#endif
#line 303 "rexxparse.y"
{clause = new ElseClause;}
break;
#if YYDEBUG
case 26:
  yyhistogram[25]++;
  break;
#endif
case 27:
#if YYDEBUG
  yyhistogram[26]++;
#endif
#line 304 "rexxparse.y"
{clause = new EndClause;}
break;
#if YYDEBUG
case 28:
  yyhistogram[27]++;
  break;
#endif
case 29:
#if YYDEBUG
  yyhistogram[28]++;
#endif
#line 305 "rexxparse.y"
{clause = new ExitClause;}
break;
#if YYDEBUG
case 30:
  yyhistogram[29]++;
  break;
#endif
case 31:
#if YYDEBUG
  yyhistogram[30]++;
#endif
#line 306 "rexxparse.y"
{clause = new IfClause;}
break;
#if YYDEBUG
case 32:
  yyhistogram[31]++;
  break;
#endif
case 33:
#if YYDEBUG
  yyhistogram[32]++;
#endif
#line 307 "rexxparse.y"
{clause = new InterpretClause;}
break;
#if YYDEBUG
case 34:
  yyhistogram[33]++;
  break;
#endif
case 35:
#if YYDEBUG
  yyhistogram[34]++;
#endif
#line 308 "rexxparse.y"
{clause = new IterateClause;}
break;
#if YYDEBUG
case 36:
  yyhistogram[35]++;
  break;
#endif
case 37:
#if YYDEBUG
  yyhistogram[36]++;
#endif
#line 309 "rexxparse.y"
{clause = new LeaveClause;}
break;
#if YYDEBUG
case 38:
  yyhistogram[37]++;
  break;
#endif
case 39:
#if YYDEBUG
  yyhistogram[38]++;
#endif
#line 310 "rexxparse.y"
{clause = new NopClause;}
break;
#if YYDEBUG
case 40:
  yyhistogram[39]++;
  break;
#endif
case 41:
#if YYDEBUG
  yyhistogram[40]++;
#endif
#line 311 "rexxparse.y"
{clause = new NumericClause;}
break;
#if YYDEBUG
case 42:
  yyhistogram[41]++;
  break;
#endif
case 43:
#if YYDEBUG
  yyhistogram[42]++;
#endif
#line 312 "rexxparse.y"
{clause = new OptionsClause;}
break;
#if YYDEBUG
case 44:
  yyhistogram[43]++;
  break;
#endif
case 45:
#if YYDEBUG
  yyhistogram[44]++;
#endif
#line 313 "rexxparse.y"
{clause = new OtherwiseClause; }
break;
#if YYDEBUG
case 46:
  yyhistogram[45]++;
  break;
#endif
case 47:
#if YYDEBUG
  yyhistogram[46]++;
#endif
#line 314 "rexxparse.y"
{/* see parse_instruction */}
break;
#if YYDEBUG
case 48:
  yyhistogram[47]++;
  break;
#endif
case 49:
#if YYDEBUG
  yyhistogram[48]++;
#endif
#line 315 "rexxparse.y"
{clause = new ProcedureClause;}
break;
#if YYDEBUG
case 50:
  yyhistogram[49]++;
  break;
#endif
case 51:
#if YYDEBUG
  yyhistogram[50]++;
#endif
#line 316 "rexxparse.y"
{clause = new ParsePullClause;}
break;
#if YYDEBUG
case 52:
  yyhistogram[51]++;
  break;
#endif
case 53:
#if YYDEBUG
  yyhistogram[52]++;
#endif
#line 317 "rexxparse.y"
{clause = new PushClause;}
break;
#if YYDEBUG
case 54:
  yyhistogram[53]++;
  break;
#endif
case 55:
#if YYDEBUG
  yyhistogram[54]++;
#endif
#line 318 "rexxparse.y"
{clause = new QueueClause;}
break;
#if YYDEBUG
case 56:
  yyhistogram[55]++;
  break;
#endif
case 57:
#if YYDEBUG
  yyhistogram[56]++;
#endif
#line 319 "rexxparse.y"
{clause = new ReturnClause;}
break;
#if YYDEBUG
case 58:
  yyhistogram[57]++;
  break;
#endif
case 59:
#if YYDEBUG
  yyhistogram[58]++;
#endif
#line 320 "rexxparse.y"
{clause = new SayClause;}
break;
#if YYDEBUG
case 60:
  yyhistogram[59]++;
  break;
#endif
case 61:
#if YYDEBUG
  yyhistogram[60]++;
#endif
#line 321 "rexxparse.y"
{clause = new SelectClause;}
break;
#if YYDEBUG
case 62:
  yyhistogram[61]++;
  break;
#endif
case 63:
#if YYDEBUG
  yyhistogram[62]++;
#endif
#line 322 "rexxparse.y"
{clause = new SignalClause;}
break;
#if YYDEBUG
case 64:
  yyhistogram[63]++;
  break;
#endif
case 65:
#if YYDEBUG
  yyhistogram[64]++;
#endif
#line 323 "rexxparse.y"
{clause = new ThenClause;}
break;
#if YYDEBUG
case 66:
  yyhistogram[65]++;
  break;
#endif
case 67:
#if YYDEBUG
  yyhistogram[66]++;
#endif
#line 324 "rexxparse.y"
{clause = new TraceClause;}
break;
#if YYDEBUG
case 68:
  yyhistogram[67]++;
  break;
#endif
case 69:
#if YYDEBUG
  yyhistogram[68]++;
#endif
#line 325 "rexxparse.y"
{clause = new WhenClause;}
break;
#if YYDEBUG
case 70:
  yyhistogram[69]++;
  break;
#endif
#if YYDEBUG
case 71:
  yyhistogram[70]++;
  break;
#endif
case 72:
#if YYDEBUG
  yyhistogram[71]++;
#endif
#line 338 "rexxparse.y"
{((AddressClause*)clause)->SetExpression(new LiteralExpression(*(yyvsp[0].symbol.string)));}
break;
case 73:
#if YYDEBUG
  yyhistogram[72]++;
#endif
#line 339 "rexxparse.y"
{((AddressClause*)clause)->SetEnvironment(*(yyvsp[-1].symbol.string)); ((AddressClause*)clause)->SetExpression(yyvsp[0].expression); ((AddressClause*)clause)->SetCommand();}
break;
case 74:
#if YYDEBUG
  yyhistogram[73]++;
#endif
#line 340 "rexxparse.y"
{((AddressClause*)clause)->SetEnvironment(*(yyvsp[-2].symbol.string)); ((AddressClause*)clause)->SetExpression(yyvsp[0].expression); ((AddressClause*)clause)->SetCommand();}
break;
case 75:
#if YYDEBUG
  yyhistogram[74]++;
#endif
#line 341 "rexxparse.y"
{((AddressClause*)clause)->SetExpression(yyvsp[0].expression);}
break;
case 76:
#if YYDEBUG
  yyhistogram[75]++;
#endif
#line 342 "rexxparse.y"
{((AddressClause*)clause)->SetExpression(yyvsp[0].expression);}
break;
case 77:
#if YYDEBUG
  yyhistogram[76]++;
#endif
#line 345 "rexxparse.y"
{yyval.symbol = yyvsp[0].symbol;}
break;
case 78:
#if YYDEBUG
  yyhistogram[77]++;
#endif
#line 346 "rexxparse.y"
{yyval.symbol = yyvsp[0].symbol;}
break;
#if YYDEBUG
case 79:
  yyhistogram[78]++;
  break;
#endif
#if YYDEBUG
case 80:
  yyhistogram[79]++;
  break;
#endif
#if YYDEBUG
case 81:
  yyhistogram[80]++;
  break;
#endif
#if YYDEBUG
case 82:
  yyhistogram[81]++;
  break;
#endif
#if YYDEBUG
case 83:
  yyhistogram[82]++;
  break;
#endif
case 84:
#if YYDEBUG
  yyhistogram[83]++;
#endif
#line 357 "rexxparse.y"
{((ParseClause*)clause)->NextTemplate();}
break;
#if YYDEBUG
case 85:
  yyhistogram[84]++;
  break;
#endif
#if YYDEBUG
case 86:
  yyhistogram[85]++;
  break;
#endif
#if YYDEBUG
case 87:
  yyhistogram[86]++;
  break;
#endif
case 88:
#if YYDEBUG
  yyhistogram[87]++;
#endif
#line 364 "rexxparse.y"
{
	((ParseClause*)clause)->AddPattern(*(yyvsp[0].symbol.string), PVariable);
	}
break;
case 89:
#if YYDEBUG
  yyhistogram[88]++;
#endif
#line 367 "rexxparse.y"
{
	ArgString as = (*(yyvsp[0].symbol.string));
	((ParseClause*)clause)->AddPattern(as, PString);
	}
break;
case 90:
#if YYDEBUG
  yyhistogram[89]++;
#endif
#line 371 "rexxparse.y"
{
	ArgString as = (*(yyvsp[0].symbol.string));
	String s = as.String();
	if (s == ".")
		((ParseClause*)clause)->AddPattern(as, PPeriod);
	else
		((ParseClause*)clause)->AddPattern(as, PAbsoluteInteger);
	}
break;
case 91:
#if YYDEBUG
  yyhistogram[90]++;
#endif
#line 379 "rexxparse.y"
{
	ArgString as = (*(yyvsp[0].symbol.string));
	((ParseClause*)clause)->AddPattern(as, PAbsoluteInteger);
	}
break;
case 92:
#if YYDEBUG
  yyhistogram[91]++;
#endif
#line 383 "rexxparse.y"
{
	ArgString as = (*(yyvsp[0].symbol.string));
	((ParseClause*)clause)->AddPattern(as, PPositiveInteger);
	}
break;
case 93:
#if YYDEBUG
  yyhistogram[92]++;
#endif
#line 387 "rexxparse.y"
{
	ArgString as = (*(yyvsp[0].symbol.string));
	((ParseClause*)clause)->AddPattern(as, PNegativeInteger);
	}
break;
case 94:
#if YYDEBUG
  yyhistogram[93]++;
#endif
#line 391 "rexxparse.y"
{
	((ParseClause*)clause)->AddPattern(*(yyvsp[-1].symbol.string), PStringReference);
	}
break;
case 95:
#if YYDEBUG
  yyhistogram[94]++;
#endif
#line 394 "rexxparse.y"
{
	((ParseClause*)clause)->AddPattern(*(yyvsp[-1].symbol.string), PAbsoluteReference);
	}
break;
case 96:
#if YYDEBUG
  yyhistogram[95]++;
#endif
#line 397 "rexxparse.y"
{
	((ParseClause*)clause)->AddPattern(*(yyvsp[-1].symbol.string), PPositiveReference);
	}
break;
case 97:
#if YYDEBUG
  yyhistogram[96]++;
#endif
#line 400 "rexxparse.y"
{
	((ParseClause*)clause)->AddPattern(*(yyvsp[-1].symbol.string), PNegativeReference);
	}
break;
case 98:
#if YYDEBUG
  yyhistogram[97]++;
#endif
#line 403 "rexxparse.y"
{
	((ParseClause*)clause)->AddPattern(*(yyvsp[0].symbol.string), PVariable);
	}
break;
case 99:
#if YYDEBUG
  yyhistogram[98]++;
#endif
#line 406 "rexxparse.y"
{
	ArgString as = (*(yyvsp[0].symbol.string));
	((ParseClause*)clause)->AddPattern(as, PString);
	}
break;
case 100:
#if YYDEBUG
  yyhistogram[99]++;
#endif
#line 410 "rexxparse.y"
{
	ArgString as = (*(yyvsp[0].symbol.string));
	String s = as.String();
	if (s == ".")
		((ParseClause*)clause)->AddPattern(as, PPeriod);
	else
		((ParseClause*)clause)->AddPattern(as, PAbsoluteInteger);
	}
break;
case 101:
#if YYDEBUG
  yyhistogram[100]++;
#endif
#line 418 "rexxparse.y"
{
	ArgString as = (*(yyvsp[0].symbol.string));
	((ParseClause*)clause)->AddPattern(as, PAbsoluteInteger);
	}
break;
case 102:
#if YYDEBUG
  yyhistogram[101]++;
#endif
#line 422 "rexxparse.y"
{
	ArgString as = (*(yyvsp[0].symbol.string));
	((ParseClause*)clause)->AddPattern(as, PPositiveInteger);
	}
break;
case 103:
#if YYDEBUG
  yyhistogram[102]++;
#endif
#line 426 "rexxparse.y"
{
	ArgString as = (*(yyvsp[0].symbol.string));
	((ParseClause*)clause)->AddPattern(as, PNegativeInteger);
	}
break;
case 104:
#if YYDEBUG
  yyhistogram[103]++;
#endif
#line 430 "rexxparse.y"
{
	((ParseClause*)clause)->AddPattern(*(yyvsp[-1].symbol.string), PStringReference);
	}
break;
case 105:
#if YYDEBUG
  yyhistogram[104]++;
#endif
#line 433 "rexxparse.y"
{
	((ParseClause*)clause)->AddPattern(*(yyvsp[-1].symbol.string), PAbsoluteReference);
	}
break;
case 106:
#if YYDEBUG
  yyhistogram[105]++;
#endif
#line 436 "rexxparse.y"
{
	((ParseClause*)clause)->AddPattern(*(yyvsp[-1].symbol.string), PPositiveReference);
	}
break;
case 107:
#if YYDEBUG
  yyhistogram[106]++;
#endif
#line 439 "rexxparse.y"
{
	((ParseClause*)clause)->AddPattern(*(yyvsp[-1].symbol.string), PNegativeReference);
	}
break;
#if YYDEBUG
case 108:
  yyhistogram[107]++;
  break;
#endif
case 109:
#if YYDEBUG
  yyhistogram[108]++;
#endif
#line 449 "rexxparse.y"
{
	((CallClause*)clause)->SetExpression(new FunctionExpression(*(yyvsp[-1].symbol.string), yyvsp[0].expressionlist));
	}
break;
case 110:
#if YYDEBUG
  yyhistogram[109]++;
#endif
#line 452 "rexxparse.y"
{
	((CallClause*)clause)->SetExpression(new FunctionExpression(*(yyvsp[-2].symbol.string), yyvsp[0].expressionlist));
	}
break;
case 111:
#if YYDEBUG
  yyhistogram[110]++;
#endif
#line 455 "rexxparse.y"
{
	((CallClause*)clause)->SetExpression(new FunctionExpression(*(yyvsp[-1].symbol.string), yyvsp[0].expressionlist, 1));
	}
break;
case 112:
#if YYDEBUG
  yyhistogram[111]++;
#endif
#line 458 "rexxparse.y"
{
	((CallClause*)clause)->SetExpression(new FunctionExpression(*(yyvsp[-2].symbol.string), yyvsp[0].expressionlist, 1));
	}
break;
case 113:
#if YYDEBUG
  yyhistogram[112]++;
#endif
#line 461 "rexxparse.y"
{
	((CallClause*)clause)->SetExpression(new FunctionExpression(*(yyvsp[-3].symbol.string), yyvsp[-1].expressionlist));
	}
break;
case 114:
#if YYDEBUG
  yyhistogram[113]++;
#endif
#line 464 "rexxparse.y"
{
	((CallClause*)clause)->SetExpression(new FunctionExpression(*(yyvsp[-3].symbol.string), yyvsp[-1].expressionlist, 1));
	}
break;
case 115:
#if YYDEBUG
  yyhistogram[114]++;
#endif
#line 467 "rexxparse.y"
{
	((CallClause*)clause)->TurnOn(SigFailure);
	}
break;
case 116:
#if YYDEBUG
  yyhistogram[115]++;
#endif
#line 470 "rexxparse.y"
{
	((CallClause*)clause)->TurnOn(SigError);
	}
break;
case 117:
#if YYDEBUG
  yyhistogram[116]++;
#endif
#line 473 "rexxparse.y"
{
	((CallClause*)clause)->TurnOn(SigHalt);
	}
break;
case 118:
#if YYDEBUG
  yyhistogram[117]++;
#endif
#line 476 "rexxparse.y"
{
	((CallClause*)clause)->TurnOn(SigNotReady);
	}
break;
case 119:
#if YYDEBUG
  yyhistogram[118]++;
#endif
#line 479 "rexxparse.y"
{
	((CallClause*)clause)->TurnOff(SigFailure);
	}
break;
case 120:
#if YYDEBUG
  yyhistogram[119]++;
#endif
#line 482 "rexxparse.y"
{
	((CallClause*)clause)->TurnOff(SigError);
	}
break;
case 121:
#if YYDEBUG
  yyhistogram[120]++;
#endif
#line 485 "rexxparse.y"
{
	((CallClause*)clause)->TurnOff(SigHalt);
	}
break;
case 122:
#if YYDEBUG
  yyhistogram[121]++;
#endif
#line 488 "rexxparse.y"
{
	((CallClause*)clause)->TurnOff(SigNotReady);
	}
break;
case 123:
#if YYDEBUG
  yyhistogram[122]++;
#endif
#line 491 "rexxparse.y"
{
	((CallClause*)clause)->TurnOn(SigFailure, *(yyvsp[0].symbol.string));
	}
break;
case 124:
#if YYDEBUG
  yyhistogram[123]++;
#endif
#line 494 "rexxparse.y"
{
	((CallClause*)clause)->TurnOn(SigError, *(yyvsp[0].symbol.string));
	}
break;
case 125:
#if YYDEBUG
  yyhistogram[124]++;
#endif
#line 497 "rexxparse.y"
{
	((CallClause*)clause)->TurnOn(SigHalt, *(yyvsp[0].symbol.string));
	}
break;
case 126:
#if YYDEBUG
  yyhistogram[125]++;
#endif
#line 500 "rexxparse.y"
{
	((CallClause*)clause)->TurnOn(SigNotReady, *(yyvsp[0].symbol.string));
	}
break;
#if YYDEBUG
case 127:
  yyhistogram[126]++;
  break;
#endif
#if YYDEBUG
case 128:
  yyhistogram[127]++;
  break;
#endif
#if YYDEBUG
case 129:
  yyhistogram[128]++;
  break;
#endif
#if YYDEBUG
case 130:
  yyhistogram[129]++;
  break;
#endif
case 131:
#if YYDEBUG
  yyhistogram[130]++;
#endif
#line 512 "rexxparse.y"
{((DoClause*)clause)->SetForever();}
break;
case 132:
#if YYDEBUG
  yyhistogram[131]++;
#endif
#line 513 "rexxparse.y"
{((DoClause*)clause)->SetSymbol(*(yyvsp[-5].symbol.string), yyvsp[-5].symbol.secondary); ((DoClause*)clause)->SetFrom(yyvsp[-3].expression);}
break;
case 133:
#if YYDEBUG
  yyhistogram[132]++;
#endif
#line 514 "rexxparse.y"
{((DoClause*)clause)->SetFor(yyvsp[0].expression);}
break;
#if YYDEBUG
case 134:
  yyhistogram[133]++;
  break;
#endif
case 135:
#if YYDEBUG
  yyhistogram[134]++;
#endif
#line 518 "rexxparse.y"
{((DoClause*)clause)->SetTo(yyvsp[0].expression);}
break;
#if YYDEBUG
case 136:
  yyhistogram[135]++;
  break;
#endif
case 137:
#if YYDEBUG
  yyhistogram[136]++;
#endif
#line 522 "rexxparse.y"
{((DoClause*)clause)->SetBy(yyvsp[0].expression);}
break;
#if YYDEBUG
case 138:
  yyhistogram[137]++;
  break;
#endif
case 139:
#if YYDEBUG
  yyhistogram[138]++;
#endif
#line 526 "rexxparse.y"
{((DoClause*)clause)->SetFor(yyvsp[0].expression);}
break;
case 140:
#if YYDEBUG
  yyhistogram[139]++;
#endif
#line 529 "rexxparse.y"
{((DoClause*)clause)->SetWhile(yyvsp[0].expression);}
break;
case 141:
#if YYDEBUG
  yyhistogram[140]++;
#endif
#line 530 "rexxparse.y"
{((DoClause*)clause)->SetUntil(yyvsp[0].expression);}
break;
#if YYDEBUG
case 142:
  yyhistogram[141]++;
  break;
#endif
case 143:
#if YYDEBUG
  yyhistogram[142]++;
#endif
#line 561 "rexxparse.y"
{
	((DropClause*)clause)->AddVariable(*(yyvsp[0].symbol.string));
	}
break;
case 144:
#if YYDEBUG
  yyhistogram[143]++;
#endif
#line 564 "rexxparse.y"
{
	((DropClause*)clause)->AddVariableRef(*(yyvsp[-1].symbol.string));
	}
break;
case 145:
#if YYDEBUG
  yyhistogram[144]++;
#endif
#line 567 "rexxparse.y"
{
	((DropClause*)clause)->AddVariable(*(yyvsp[0].symbol.string));
	}
break;
case 146:
#if YYDEBUG
  yyhistogram[145]++;
#endif
#line 570 "rexxparse.y"
{
	((DropClause*)clause)->AddVariableRef(*(yyvsp[-1].symbol.string));
	}
break;
#if YYDEBUG
case 147:
  yyhistogram[146]++;
  break;
#endif
#if YYDEBUG
case 148:
  yyhistogram[147]++;
  break;
#endif
#if YYDEBUG
case 149:
  yyhistogram[148]++;
  break;
#endif
#if YYDEBUG
case 150:
  yyhistogram[149]++;
  break;
#endif
#if YYDEBUG
case 151:
  yyhistogram[150]++;
  break;
#endif
#if YYDEBUG
case 152:
  yyhistogram[151]++;
  break;
#endif
case 153:
#if YYDEBUG
  yyhistogram[152]++;
#endif
#line 587 "rexxparse.y"
{((EndClause*)clause)->SetVariable(*(yyvsp[0].symbol.string));}
break;
#if YYDEBUG
case 154:
  yyhistogram[153]++;
  break;
#endif
case 155:
#if YYDEBUG
  yyhistogram[154]++;
#endif
#line 592 "rexxparse.y"
{((ExitClause*)clause)->SetExpression(yyvsp[0].expression);}
break;
case 156:
#if YYDEBUG
  yyhistogram[155]++;
#endif
#line 596 "rexxparse.y"
{((IfClause*)clause)->SetExpression(yyvsp[0].expression);}
break;
case 157:
#if YYDEBUG
  yyhistogram[156]++;
#endif
#line 600 "rexxparse.y"
{((InterpretClause*)clause)->SetExpression(yyvsp[0].expression);}
break;
#if YYDEBUG
case 158:
  yyhistogram[157]++;
  break;
#endif
case 159:
#if YYDEBUG
  yyhistogram[158]++;
#endif
#line 605 "rexxparse.y"
{((IterateClause*)clause)->SetVariable(*(yyvsp[0].symbol.string));}
break;
#if YYDEBUG
case 160:
  yyhistogram[159]++;
  break;
#endif
case 161:
#if YYDEBUG
  yyhistogram[160]++;
#endif
#line 610 "rexxparse.y"
{((LeaveClause*)clause)->SetVariable(*(yyvsp[0].symbol.string));}
break;
#if YYDEBUG
case 162:
  yyhistogram[161]++;
  break;
#endif
case 163:
#if YYDEBUG
  yyhistogram[162]++;
#endif
#line 618 "rexxparse.y"
{((NumericClause*)clause)->SetDigits(yyvsp[0].expression);}
break;
case 164:
#if YYDEBUG
  yyhistogram[163]++;
#endif
#line 619 "rexxparse.y"
{((NumericClause*)clause)->SetFuzz(yyvsp[0].expression);}
break;
case 165:
#if YYDEBUG
  yyhistogram[164]++;
#endif
#line 620 "rexxparse.y"
{((NumericClause*)clause)->SetForm(new LiteralExpression(ArgString("SCIENTIFIC")));}
break;
case 166:
#if YYDEBUG
  yyhistogram[165]++;
#endif
#line 621 "rexxparse.y"
{((NumericClause*)clause)->SetForm(new LiteralExpression(ArgString("ENGINEERING")));}
break;
case 167:
#if YYDEBUG
  yyhistogram[166]++;
#endif
#line 622 "rexxparse.y"
{((NumericClause*)clause)->SetForm(yyvsp[0].expression);}
break;
case 168:
#if YYDEBUG
  yyhistogram[167]++;
#endif
#line 626 "rexxparse.y"
{((OptionsClause*)clause)->SetExpression(yyvsp[0].expression);}
break;
#if YYDEBUG
case 169:
  yyhistogram[168]++;
  break;
#endif
case 170:
#if YYDEBUG
  yyhistogram[169]++;
#endif
#line 634 "rexxparse.y"
{clause = new ParseArgClause;}
break;
#if YYDEBUG
case 171:
  yyhistogram[170]++;
  break;
#endif
case 172:
#if YYDEBUG
  yyhistogram[171]++;
#endif
#line 635 "rexxparse.y"
{clause = new ParseLineinClause;}
break;
#if YYDEBUG
case 173:
  yyhistogram[172]++;
  break;
#endif
case 174:
#if YYDEBUG
  yyhistogram[173]++;
#endif
#line 636 "rexxparse.y"
{clause = new ParseExternalClause;}
break;
#if YYDEBUG
case 175:
  yyhistogram[174]++;
  break;
#endif
case 176:
#if YYDEBUG
  yyhistogram[175]++;
#endif
#line 637 "rexxparse.y"
{clause = new ParsePullClause;}
break;
#if YYDEBUG
case 177:
  yyhistogram[176]++;
  break;
#endif
case 178:
#if YYDEBUG
  yyhistogram[177]++;
#endif
#line 638 "rexxparse.y"
{clause = new ParseSourceClause;}
break;
#if YYDEBUG
case 179:
  yyhistogram[178]++;
  break;
#endif
case 180:
#if YYDEBUG
  yyhistogram[179]++;
#endif
#line 639 "rexxparse.y"
{clause = new ParseValueClause;}
break;
case 181:
#if YYDEBUG
  yyhistogram[180]++;
#endif
#line 639 "rexxparse.y"
{((ParseValueClause*)clause)->SetExpression(yyvsp[-2].expression);}
break;
case 182:
#if YYDEBUG
  yyhistogram[181]++;
#endif
#line 640 "rexxparse.y"
{clause = new ParseVarClause;}
break;
case 183:
#if YYDEBUG
  yyhistogram[182]++;
#endif
#line 640 "rexxparse.y"
{((ParseVarClause*)clause)->SetVariable(*(yyvsp[-1].symbol.string), yyvsp[-1].symbol.secondary);}
break;
case 184:
#if YYDEBUG
  yyhistogram[183]++;
#endif
#line 641 "rexxparse.y"
{clause = new ParseVersionClause;}
break;
#if YYDEBUG
case 185:
  yyhistogram[184]++;
  break;
#endif
case 186:
#if YYDEBUG
  yyhistogram[185]++;
#endif
#line 642 "rexxparse.y"
{clause = new ParseArgClause;}
break;
case 187:
#if YYDEBUG
  yyhistogram[186]++;
#endif
#line 642 "rexxparse.y"
{((ParseArgClause*)clause)->Upper();}
break;
case 188:
#if YYDEBUG
  yyhistogram[187]++;
#endif
#line 643 "rexxparse.y"
{clause = new ParseLineinClause;}
break;
case 189:
#if YYDEBUG
  yyhistogram[188]++;
#endif
#line 643 "rexxparse.y"
{((ParseLineinClause*)clause)->Upper();}
break;
case 190:
#if YYDEBUG
  yyhistogram[189]++;
#endif
#line 644 "rexxparse.y"
{clause = new ParseExternalClause;}
break;
case 191:
#if YYDEBUG
  yyhistogram[190]++;
#endif
#line 644 "rexxparse.y"
{((ParseExternalClause*)clause)->Upper();}
break;
case 192:
#if YYDEBUG
  yyhistogram[191]++;
#endif
#line 645 "rexxparse.y"
{clause = new ParsePullClause;}
break;
case 193:
#if YYDEBUG
  yyhistogram[192]++;
#endif
#line 645 "rexxparse.y"
{((ParsePullClause*)clause)->Upper();}
break;
case 194:
#if YYDEBUG
  yyhistogram[193]++;
#endif
#line 646 "rexxparse.y"
{clause = new ParseSourceClause;}
break;
case 195:
#if YYDEBUG
  yyhistogram[194]++;
#endif
#line 646 "rexxparse.y"
{((ParseSourceClause*)clause)->Upper();}
break;
case 196:
#if YYDEBUG
  yyhistogram[195]++;
#endif
#line 647 "rexxparse.y"
{clause = new ParseValueClause;}
break;
case 197:
#if YYDEBUG
  yyhistogram[196]++;
#endif
#line 647 "rexxparse.y"
{((ParseValueClause*)clause)->SetExpression(yyvsp[-2].expression); ((ParseValueClause*)clause)->Upper();}
break;
case 198:
#if YYDEBUG
  yyhistogram[197]++;
#endif
#line 648 "rexxparse.y"
{clause = new ParseVarClause;}
break;
case 199:
#if YYDEBUG
  yyhistogram[198]++;
#endif
#line 648 "rexxparse.y"
{((ParseVarClause*)clause)->SetVariable(*(yyvsp[-1].symbol.string), yyvsp[-1].symbol.secondary); ((ParseVarClause*)clause)->Upper();}
break;
case 200:
#if YYDEBUG
  yyhistogram[199]++;
#endif
#line 649 "rexxparse.y"
{clause = new ParseVersionClause;}
break;
case 201:
#if YYDEBUG
  yyhistogram[200]++;
#endif
#line 649 "rexxparse.y"
{((ParseVersionClause*)clause)->Upper();}
break;
#if YYDEBUG
case 202:
  yyhistogram[201]++;
  break;
#endif
#if YYDEBUG
case 203:
  yyhistogram[202]++;
  break;
#endif
case 204:
#if YYDEBUG
  yyhistogram[203]++;
#endif
#line 657 "rexxparse.y"
{
	((ProcedureClause*)clause)->AddVariable(*(yyvsp[0].symbol.string));
	}
break;
case 205:
#if YYDEBUG
  yyhistogram[204]++;
#endif
#line 660 "rexxparse.y"
{
	((ProcedureClause*)clause)->AddVariableRef(*(yyvsp[-1].symbol.string));
	}
break;
case 206:
#if YYDEBUG
  yyhistogram[205]++;
#endif
#line 663 "rexxparse.y"
{
	((ProcedureClause*)clause)->AddVariable(*(yyvsp[0].symbol.string));
	}
break;
case 207:
#if YYDEBUG
  yyhistogram[206]++;
#endif
#line 666 "rexxparse.y"
{
	((ProcedureClause*)clause)->AddVariableRef(*(yyvsp[-1].symbol.string));
	}
break;
#if YYDEBUG
case 208:
  yyhistogram[207]++;
  break;
#endif
#if YYDEBUG
case 209:
  yyhistogram[208]++;
  break;
#endif
case 210:
#if YYDEBUG
  yyhistogram[209]++;
#endif
#line 680 "rexxparse.y"
{((PushClause*)clause)->SetExpression(yyvsp[0].expression);}
break;
#if YYDEBUG
case 211:
  yyhistogram[210]++;
  break;
#endif
case 212:
#if YYDEBUG
  yyhistogram[211]++;
#endif
#line 685 "rexxparse.y"
{((QueueClause*)clause)->SetExpression(yyvsp[0].expression);}
break;
#if YYDEBUG
case 213:
  yyhistogram[212]++;
  break;
#endif
case 214:
#if YYDEBUG
  yyhistogram[213]++;
#endif
#line 690 "rexxparse.y"
{((ReturnClause*)clause)->SetExpression(yyvsp[0].expression);}
break;
case 215:
#if YYDEBUG
  yyhistogram[214]++;
#endif
#line 694 "rexxparse.y"
{((SayClause*)clause)->SetExpression(0);}
break;
case 216:
#if YYDEBUG
  yyhistogram[215]++;
#endif
#line 695 "rexxparse.y"
{((SayClause*)clause)->SetExpression(yyvsp[0].expression);}
break;
#if YYDEBUG
case 217:
  yyhistogram[216]++;
  break;
#endif
case 218:
#if YYDEBUG
  yyhistogram[217]++;
#endif
#line 703 "rexxparse.y"
{
	((SignalClause*)clause)->SetExpression(new LiteralExpression(*(yyvsp[0].symbol.string)));
	}
break;
case 219:
#if YYDEBUG
  yyhistogram[218]++;
#endif
#line 706 "rexxparse.y"
{
	((SignalClause*)clause)->SetExpression(new LiteralExpression(*(yyvsp[0].symbol.string)));
	}
break;
case 220:
#if YYDEBUG
  yyhistogram[219]++;
#endif
#line 709 "rexxparse.y"
{
	((SignalClause*)clause)->SetExpression(yyvsp[0].expression);
	}
break;
case 221:
#if YYDEBUG
  yyhistogram[220]++;
#endif
#line 712 "rexxparse.y"
{
	((SignalClause*)clause)->TurnOn(SigError, *(yyvsp[0].symbol.string));
	}
break;
case 222:
#if YYDEBUG
  yyhistogram[221]++;
#endif
#line 715 "rexxparse.y"
{
	((SignalClause*)clause)->TurnOn(SigFailure, *(yyvsp[0].symbol.string));
	}
break;
case 223:
#if YYDEBUG
  yyhistogram[222]++;
#endif
#line 718 "rexxparse.y"
{
	((SignalClause*)clause)->TurnOn(SigHalt, *(yyvsp[0].symbol.string));
	}
break;
case 224:
#if YYDEBUG
  yyhistogram[223]++;
#endif
#line 721 "rexxparse.y"
{
	((SignalClause*)clause)->TurnOn(SigNotReady, *(yyvsp[0].symbol.string));
	}
break;
case 225:
#if YYDEBUG
  yyhistogram[224]++;
#endif
#line 724 "rexxparse.y"
{
	((SignalClause*)clause)->TurnOn(SigNoValue, *(yyvsp[0].symbol.string));
	}
break;
case 226:
#if YYDEBUG
  yyhistogram[225]++;
#endif
#line 727 "rexxparse.y"
{
	((SignalClause*)clause)->TurnOn(SigSyntax, *(yyvsp[0].symbol.string));
	}
break;
case 227:
#if YYDEBUG
  yyhistogram[226]++;
#endif
#line 731 "rexxparse.y"
{
	((SignalClause*)clause)->TurnOn(SigError, ArgString());
	}
break;
case 228:
#if YYDEBUG
  yyhistogram[227]++;
#endif
#line 734 "rexxparse.y"
{
	((SignalClause*)clause)->TurnOn(SigFailure, ArgString());
	}
break;
case 229:
#if YYDEBUG
  yyhistogram[228]++;
#endif
#line 737 "rexxparse.y"
{
	((SignalClause*)clause)->TurnOn(SigHalt, ArgString());
	}
break;
case 230:
#if YYDEBUG
  yyhistogram[229]++;
#endif
#line 740 "rexxparse.y"
{
	((SignalClause*)clause)->TurnOn(SigNotReady, ArgString());
	}
break;
case 231:
#if YYDEBUG
  yyhistogram[230]++;
#endif
#line 743 "rexxparse.y"
{
	((SignalClause*)clause)->TurnOn(SigNoValue, ArgString());
	}
break;
case 232:
#if YYDEBUG
  yyhistogram[231]++;
#endif
#line 746 "rexxparse.y"
{
	((SignalClause*)clause)->TurnOn(SigSyntax, ArgString());
	}
break;
case 233:
#if YYDEBUG
  yyhistogram[232]++;
#endif
#line 750 "rexxparse.y"
{
	((SignalClause*)clause)->TurnOff(SigHalt);
	}
break;
case 234:
#if YYDEBUG
  yyhistogram[233]++;
#endif
#line 753 "rexxparse.y"
{
	((SignalClause*)clause)->TurnOff(SigFailure);
	}
break;
case 235:
#if YYDEBUG
  yyhistogram[234]++;
#endif
#line 756 "rexxparse.y"
{
	((SignalClause*)clause)->TurnOff(SigHalt);
	}
break;
case 236:
#if YYDEBUG
  yyhistogram[235]++;
#endif
#line 759 "rexxparse.y"
{
	((SignalClause*)clause)->TurnOff(SigNotReady);
	}
break;
case 237:
#if YYDEBUG
  yyhistogram[236]++;
#endif
#line 762 "rexxparse.y"
{
	((SignalClause*)clause)->TurnOff(SigNoValue);
	}
break;
case 238:
#if YYDEBUG
  yyhistogram[237]++;
#endif
#line 765 "rexxparse.y"
{
	((SignalClause*)clause)->TurnOff(SigSyntax);
	}
break;
case 239:
#if YYDEBUG
  yyhistogram[238]++;
#endif
#line 770 "rexxparse.y"
{((TraceClause*)clause)->SetExpression(new LiteralExpression(*(yyvsp[0].symbol.string)));}
break;
case 240:
#if YYDEBUG
  yyhistogram[239]++;
#endif
#line 771 "rexxparse.y"
{((TraceClause*)clause)->SetExpression(yyvsp[0].expression);}
break;
#if YYDEBUG
case 241:
  yyhistogram[240]++;
  break;
#endif
case 242:
#if YYDEBUG
  yyhistogram[241]++;
#endif
#line 784 "rexxparse.y"
{((WhenClause*)clause)->SetExpression(yyvsp[0].expression);}
break;
case 243:
#if YYDEBUG
  yyhistogram[242]++;
#endif
#line 788 "rexxparse.y"
{yyval.expression = new ErrorExpression(EInvalidExpression);}
break;
case 244:
#if YYDEBUG
  yyhistogram[243]++;
#endif
#line 793 "rexxparse.y"
{
                   switch(yyvsp[0].symbol.secondary) {
                     case TOK_SIMPLE :
		       yyval.expression = new SimpleSymExpression(*(yyvsp[0].symbol.string)); break;
                     case TOK_COMPOUND : 
                       yyval.expression = new CompoundSymExpression(*(yyvsp[0].symbol.string)); break;
                     case TOK_STEM :
		       yyval.expression = new StemSymExpression(*(yyvsp[0].symbol.string)); break;
		   };
                 }
break;
case 245:
#if YYDEBUG
  yyhistogram[244]++;
#endif
#line 803 "rexxparse.y"
{yyval.expression = new LiteralExpression(*(yyvsp[0].symbol.string));}
break;
case 246:
#if YYDEBUG
  yyhistogram[245]++;
#endif
#line 804 "rexxparse.y"
{yyval.expression = new LiteralExpression(*(yyvsp[0].symbol.string));}
break;
case 247:
#if YYDEBUG
  yyhistogram[246]++;
#endif
#line 805 "rexxparse.y"
{yyval.expression = yyvsp[-1].expression;}
break;
case 248:
#if YYDEBUG
  yyhistogram[247]++;
#endif
#line 806 "rexxparse.y"
{yyval.expression = yyvsp[0].expression;}
break;
case 249:
#if YYDEBUG
  yyhistogram[248]++;
#endif
#line 807 "rexxparse.y"
{yyval.expression = new NotExpression(yyvsp[0].expression);}
break;
case 250:
#if YYDEBUG
  yyhistogram[249]++;
#endif
#line 808 "rexxparse.y"
{yyval.expression = new ExponentExpression(yyvsp[-2].expression, yyvsp[0].expression);}
break;
case 251:
#if YYDEBUG
  yyhistogram[250]++;
#endif
#line 809 "rexxparse.y"
{yyval.expression = new NegativeExpression(yyvsp[0].expression);}
break;
case 252:
#if YYDEBUG
  yyhistogram[251]++;
#endif
#line 810 "rexxparse.y"
{yyval.expression = new PositiveExpression(yyvsp[0].expression);}
break;
case 253:
#if YYDEBUG
  yyhistogram[252]++;
#endif
#line 811 "rexxparse.y"
{yyval.expression = new MultiplyExpression(yyvsp[-2].expression, yyvsp[0].expression);}
break;
case 254:
#if YYDEBUG
  yyhistogram[253]++;
#endif
#line 812 "rexxparse.y"
{yyval.expression = new IntDivideExpression(yyvsp[-2].expression, yyvsp[0].expression);}
break;
case 255:
#if YYDEBUG
  yyhistogram[254]++;
#endif
#line 813 "rexxparse.y"
{yyval.expression = new RemainderExpression(yyvsp[-2].expression, yyvsp[0].expression);}
break;
case 256:
#if YYDEBUG
  yyhistogram[255]++;
#endif
#line 814 "rexxparse.y"
{yyval.expression = new DivideExpression(yyvsp[-2].expression, yyvsp[0].expression);}
break;
case 257:
#if YYDEBUG
  yyhistogram[256]++;
#endif
#line 815 "rexxparse.y"
{yyval.expression = new SubtractExpression(yyvsp[-2].expression, yyvsp[0].expression);}
break;
case 258:
#if YYDEBUG
  yyhistogram[257]++;
#endif
#line 816 "rexxparse.y"
{yyval.expression = new AddExpression(yyvsp[-2].expression, yyvsp[0].expression);}
break;
case 259:
#if YYDEBUG
  yyhistogram[258]++;
#endif
#line 817 "rexxparse.y"
{yyval.expression = new BlankExpression(yyvsp[-2].expression, yyvsp[0].expression);}
break;
case 260:
#if YYDEBUG
  yyhistogram[259]++;
#endif
#line 818 "rexxparse.y"
{yyval.expression = new ConcatExpression(yyvsp[-2].expression, yyvsp[0].expression);}
break;
case 261:
#if YYDEBUG
  yyhistogram[260]++;
#endif
#line 819 "rexxparse.y"
{yyval.expression = new EqualExpression(yyvsp[-2].expression, yyvsp[0].expression);}
break;
case 262:
#if YYDEBUG
  yyhistogram[261]++;
#endif
#line 820 "rexxparse.y"
{yyval.expression = new NotEqualExpression(yyvsp[-2].expression, yyvsp[0].expression);}
break;
case 263:
#if YYDEBUG
  yyhistogram[262]++;
#endif
#line 821 "rexxparse.y"
{yyval.expression = new LessEqualExpression(yyvsp[-2].expression, yyvsp[0].expression);}
break;
case 264:
#if YYDEBUG
  yyhistogram[263]++;
#endif
#line 822 "rexxparse.y"
{yyval.expression = new GreaterEqualExpression(yyvsp[-2].expression, yyvsp[0].expression);}
break;
case 265:
#if YYDEBUG
  yyhistogram[264]++;
#endif
#line 823 "rexxparse.y"
{yyval.expression = new LessThanExpression(yyvsp[-2].expression, yyvsp[0].expression);}
break;
case 266:
#if YYDEBUG
  yyhistogram[265]++;
#endif
#line 824 "rexxparse.y"
{yyval.expression = new GreaterThanExpression(yyvsp[-2].expression, yyvsp[0].expression);}
break;
case 267:
#if YYDEBUG
  yyhistogram[266]++;
#endif
#line 825 "rexxparse.y"
{yyval.expression = new ExactEqualExpression(yyvsp[-2].expression, yyvsp[0].expression);}
break;
case 268:
#if YYDEBUG
  yyhistogram[267]++;
#endif
#line 826 "rexxparse.y"
{yyval.expression = new ExactNotEqualExpression(yyvsp[-2].expression, yyvsp[0].expression);}
break;
case 269:
#if YYDEBUG
  yyhistogram[268]++;
#endif
#line 827 "rexxparse.y"
{yyval.expression = new ExactLessEqualExpression(yyvsp[-2].expression, yyvsp[0].expression);}
break;
case 270:
#if YYDEBUG
  yyhistogram[269]++;
#endif
#line 828 "rexxparse.y"
{yyval.expression = new ExactGreaterEqualExpression(yyvsp[-2].expression, yyvsp[0].expression);}
break;
case 271:
#if YYDEBUG
  yyhistogram[270]++;
#endif
#line 829 "rexxparse.y"
{yyval.expression = new ExactLessThanExpression(yyvsp[-2].expression, yyvsp[0].expression);}
break;
case 272:
#if YYDEBUG
  yyhistogram[271]++;
#endif
#line 830 "rexxparse.y"
{yyval.expression = new ExactGreaterThanExpression(yyvsp[-2].expression, yyvsp[0].expression);}
break;
case 273:
#if YYDEBUG
  yyhistogram[272]++;
#endif
#line 831 "rexxparse.y"
{yyval.expression = new AndExpression(yyvsp[-2].expression, yyvsp[0].expression);}
break;
case 274:
#if YYDEBUG
  yyhistogram[273]++;
#endif
#line 832 "rexxparse.y"
{yyval.expression = new OrExpression(yyvsp[-2].expression, yyvsp[0].expression);}
break;
case 275:
#if YYDEBUG
  yyhistogram[274]++;
#endif
#line 833 "rexxparse.y"
{yyval.expression = new XorExpression(yyvsp[-2].expression, yyvsp[0].expression);}
break;
case 276:
#if YYDEBUG
  yyhistogram[275]++;
#endif
#line 837 "rexxparse.y"
{
	yyval.expression = new FunctionExpression(*(yyvsp[-3].symbol.string), yyvsp[-1].expressionlist);
    }
break;
case 277:
#if YYDEBUG
  yyhistogram[276]++;
#endif
#line 840 "rexxparse.y"
{
	yyval.expression = new FunctionExpression(*(yyvsp[-3].symbol.string), yyvsp[-1].expressionlist, 1); /* skip search*/
    }
break;
case 278:
#if YYDEBUG
  yyhistogram[277]++;
#endif
#line 851 "rexxparse.y"
{
    yyval.expressionlist->append(yyvsp[0].expression);}
break;
case 279:
#if YYDEBUG
  yyhistogram[278]++;
#endif
#line 853 "rexxparse.y"
{yyval.expressionlist->append((Expression*)0);}
break;
case 280:
#if YYDEBUG
  yyhistogram[279]++;
#endif
#line 854 "rexxparse.y"
{yyval.expressionlist = new ExpressionpSLList; yyval.expressionlist->append(yyvsp[0].expression);}
break;
case 281:
#if YYDEBUG
  yyhistogram[280]++;
#endif
#line 855 "rexxparse.y"
{yyval.expressionlist = new ExpressionpSLList; yyval.expressionlist->append((Expression*)0);}
break;
#line 3454 "rexxparse.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug && 5 > yydebug)
            printf("yydebug: after reduction, shifting from state 0 to\
 state %d\n", YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                if (5 > yydebug)
                    printf("yydebug: state %d, reading %d (%s)\n",
                        YYFINAL, yychar, yys);
                else if (yydebug == 6)
                    YYDEBUG_LOOK_AHEAD(YYFINAL, yychar, yys, yyssp-yyss);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug && 5 > yydebug)
        printf("yydebug: after reduction, shifting from state %d \
to state %d\n", *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
#if YYDEBUG
    if (yydebug && yydebug == 7)
        print_histogram();
#endif
    return (1);
yyaccept:
#if YYDEBUG
    if (yydebug && yydebug == 7)
        print_histogram();
#endif
    return (0);
}
