#define TOK_OR 257
#define TOK_XOR 258
#define TOK_AND 259
#define TOK_EQUAL 260
#define TOK_GREATER_EQUAL 261
#define TOK_GREATER_THAN 262
#define TOK_LESS_EQUAL 263
#define TOK_LESS_THAN 264
#define TOK_NOT_EQUAL 265
#define TOK_EXACT_EQUAL 266
#define TOK_EXACT_NOT_EQUAL 267
#define TOK_EXACT_GREATER_EQUAL 268
#define TOK_EXACT_GREATER_THAN 269
#define TOK_EXACT_LESS_EQUAL 270
#define TOK_EXACT_LESS_THAN 271
#define TOK_BLANK 272
#define TOK_CONCAT 273
#define TOK_MINUS 274
#define TOK_PLUS 275
#define TOK_INT_DIV 276
#define TOK_REMAINDER 277
#define TOK_REAL_DIV 278
#define TOK_MULT 279
#define NEGATIVE 280
#define POSITIVE 281
#define TOK_EXP 282
#define TOK_NOT 283
#define TOK_COMMA 284
#define TOK_LPAREN 285
#define TOK_RPAREN 286
#define TOK_NEWLINE 287
#define TOK_STRING_LITERAL 288
#define TOK_LABEL 289
#define TOK_COLON 290
#define TOK_SYMBOL 291
#define TOK_FIXED 292
#define TOK_STEM 293
#define TOK_COMPOUND 294
#define TOK_SIMPLE 295
#define TOK_ASSIGNMENT 296
#define TOK_NULLCLAUSE 297
#define TOK_ERRORCLAUSE 298
#define TOK_COMMANDCLAUSE 299
#define TOK_LINENUMBER 300
#define TOK_ADDRESS 301
#define TOK_ADDRESS_SS 302
#define TOK_ADDRESS_VALUE 303
#define TOK_VALUE 304
#define TOK_ARG 305
#define TOK_BREAK 306
#define TOK_CALL 307
#define TOK_ON 308
#define TOK_OFF 309
#define TOK_FAILURE 310
#define TOK_ERROR 311
#define TOK_HALT 312
#define TOK_NOTREADY 313
#define TOK_CALL_ON_FAILURE 314
#define TOK_CALL_ON_ERROR 315
#define TOK_CALL_ON_HALT 316
#define TOK_CALL_ON_NOTREADY 317
#define TOK_CALL_OFF_FAILURE 318
#define TOK_CALL_OFF_ERROR 319
#define TOK_CALL_OFF_HALT 320
#define TOK_CALL_OFF_NOTREADY 321
#define TOK_NAME 322
#define TOK_CALL_ON_FAILURE_NAME 323
#define TOK_CALL_ON_ERROR_NAME 324
#define TOK_CALL_ON_HALT_NAME 325
#define TOK_CALL_ON_NOTREADY_NAME 326
#define TOK_DO 327
#define TOK_TO 328
#define TOK_BY 329
#define TOK_FOR 330
#define TOK_FOREVER 331
#define TOK_WHILE 332
#define TOK_UNTIL 333
#define TOK_DROP 334
#define TOK_SAY 335
#define TOK_ELSE 336
#define TOK_END 337
#define TOK_EXIT 338
#define TOK_EOF 339
#define TOK_IF 340
#define TOK_WHEN 341
#define TOK_THEN 342
#define TOK_INTERPRET 343
#define TOK_ITERATE 344
#define TOK_LEAVE 345
#define TOK_NOP 346
#define TOK_DIGITS 347
#define TOK_FUZZ 348
#define TOK_FORM 349
#define TOK_SCIENTIFIC 350
#define TOK_ENGINEERING 351
#define TOK_NUMERIC 352
#define TOK_NUMERIC_DIGITS 353
#define TOK_NUMERIC_FUZZ 354
#define TOK_NUMERIC_FORM_SCIENTIFIC 355
#define TOK_NUMERIC_FORM_ENGINEERING 356
#define TOK_NUMERIC_FORM_VALUE 357
#define TOK_OPTIONS 358
#define TOK_OTHERWISE 359
#define TOK_LINEIN 360
#define TOK_EXTERNAL 361
#define TOK_SOURCE 362
#define TOK_VAR 363
#define TOK_VERSION 364
#define TOK_PARSE 365
#define TOK_PARSE_ARG 366
#define TOK_PARSE_LINEIN 367
#define TOK_PARSE_EXTERNAL 368
#define TOK_PARSE_PULL 369
#define TOK_PARSE_SOURCE 370
#define TOK_PARSE_VALUE 371
#define TOK_WITH 372
#define TOK_PARSE_VAR 373
#define TOK_PARSE_VERSION 374
#define TOK_PARSE_UPPER_ARG 375
#define TOK_PARSE_UPPER_LINEIN 376
#define TOK_PARSE_UPPER_EXTERNAL 377
#define TOK_PARSE_UPPER_NUMERIC 378
#define TOK_PARSE_UPPER_PULL 379
#define TOK_PARSE_UPPER_SOURCE 380
#define TOK_PARSE_UPPER_VALUE 381
#define TOK_PARSE_UPPER_VAR 382
#define TOK_PARSE_UPPER_VERSION 383
#define TOK_EXPOSE 384
#define TOK_PROCEDURE 385
#define TOK_PROCEDURE_EXPOSE 386
#define TOK_PULL 387
#define TOK_PUSH 388
#define TOK_QUEUE 389
#define TOK_RETURN 390
#define TOK_SELECT 391
#define TOK_SYNTAX 392
#define TOK_NOVALUE 393
#define TOK_SIGNAL 394
#define TOK_SIGNAL_ON_FAILURE 395
#define TOK_SIGNAL_ON_ERROR 396
#define TOK_SIGNAL_ON_HALT 397
#define TOK_SIGNAL_ON_NOTREADY 398
#define TOK_SIGNAL_ON_NOVALUE 399
#define TOK_SIGNAL_ON_SYNTAX 400
#define TOK_SIGNAL_OFF_FAILURE 401
#define TOK_SIGNAL_OFF_ERROR 402
#define TOK_SIGNAL_OFF_HALT 403
#define TOK_SIGNAL_OFF_NOTREADY 404
#define TOK_SIGNAL_OFF_NOVALUE 405
#define TOK_SIGNAL_OFF_SYNTAX 406
#define TOK_SIGNAL_ON_FAILURE_NAME 407
#define TOK_SIGNAL_ON_ERROR_NAME 408
#define TOK_SIGNAL_ON_HALT_NAME 409
#define TOK_SIGNAL_ON_NOTREADY_NAME 410
#define TOK_SIGNAL_ON_NOVALUE_NAME 411
#define TOK_SIGNAL_ON_SYNTAX_NAME 412
#define TOK_SIGNAL_VALUE 413
#define TOK_TRACE 414
#define TOK_TRACE_SS 415
#define TOK_TRACE_VALUE 416
#define TOK_UPPER 417
#define TOK_UNKNOWN 418
typedef union{
    struct {
	ArgString* string;
	int secondary;
    } symbol;
    ArgString* string;
    Expression* expression;
    ExpressionpSLList* expressionlist;
} YYSTYPE;
extern YYSTYPE yylval;
