// -*- C++ -*-
//-----------------
//--- Builtin.h ---
//-----------------
/*
 * Responsibility: built-in class
 * Role: 
 * Communications: 
 * Bugs & Caveats: 
 * Created: Fri Mar  6 15:13:30 1992 by rvillari
 * Maintainer: 
 * 
 * $Id: Builtin.h,v 1.1 92/03/29 09:18:24 rvillari Exp Locker: rvillari $
 * $Log:	Builtin.h,v $
 * Revision 1.1  92/03/29  09:18:24  rvillari
 * Initial revision
 * 
 * 
 * 
*/


#ifndef _Builtin_h
#pragma once
#define _Builtin_h 1

// class responsible for all the builtin functions
#include "Name.Functionp.VHMap.h"

// put built-in functions here -- they are dispatched by Dispatch
void ABBREV();
void ABS();
void ADDRESS();
void ARG();

class Builtin {
  private:
    NameFunctionpVHMap functions;

  public:
    Builtin();
    void Preload();
    int Exists(String); // check if we have the function here
    Functionp GetFunction(String&);
    void Dispatch(String); // dispatch the function
   ~Builtin();
};

#endif 
