// -*- C++ -*-
//------------------------
//--- Implementation.h ---
//------------------------
/*
 * Responsibility: 
 * Role: 
 * Communications: 
 * Bugs & Caveats: 
 * Created: Thu Mar 12 15:11:06 1992 by rvillari
 * Maintainer: 
 * 
 * $Id: Implementation.h,v 1.1 92/03/29 09:18:52 rvillari Exp Locker: rvillari $
 * $Log:	Implementation.h,v $
 * Revision 1.1  92/03/29  09:18:52  rvillari
 * Initial revision
 * 
 * 
 * 
*/


#ifndef _Implementation_h
#pragma once
#define _Implementation_h 1

// these are the implementation dependent constants
const int MaxTokens = 50000; // not used anymore -- we have dynamic arrays
const int MaxClauses = 10000; // we have dynamic arrays
const int MinClauses = 10;
const int MinTokens = 100;
const int MaxArguments = 15;
const int MaxTemplates = 15;
const int MaxPatterns = 30;
const int MaxDrops = 30;
const int MaxExposes = 30;
const int MaxSignals = 10;
const int MaxWholeDigits = 9; // maximum number of digits for a whole
const int MaxDigits = 50;
#endif 

