#include "InternalEnv.h"
#include "InternalData.h"
#include <stream.h>

InternalEnv::InternalEnv() {}

InternalEnv::~InternalEnv() {
    // we should really pop everything off the stack and delete them
}

void InternalEnv::PushEnv() {
    if (env.empty()) env.push(new InternalData);
    else env.push(env.top()->Copy()); // inherit some values from upper env
}

void InternalEnv::PushEnv(InternalData* newdata) {
    env.push(newdata);
}

InternalData* InternalEnv::PopEnv() {
    if (env.empty()) {
	cout << "InternalEnv is empty!\n";
	abort();
    }
    return env.pop();
/*
    InternalData* olddata = env.top();
    env.pop();
    delete olddata;
*/
}

